SeguraFeito_TestSegm_Tri:
; in:
;    xmm0
; out:
;    eax = 1 -> yes, ray intersect triangle, otherwise - non



macro cross   ; in:   xmm0 -> first vector
              ;       xmm2 -> seconfd vector
              ; out:  xmm0 -> cross

{
  movaps  xmm1,xmm0
  movaps  xmm3,xmm2
  shufps  xmm0,xmm0,00001001b
  shufps  xmm1,xmm1,00010010b
  shufps  xmm2,xmm2,00010010b
  shufps  xmm3,xmm3,00001001b
  mulps   xmm0,xmm2
  mulps   xmm1,xmm3
  subps   xmm0,xmm1
}
;abs_mask:
;epsilon:
;the_zero:
;zero_hgst:


SeguraFeito_TestSegmTriPrecalc:
;  in:  esi  - triangles
;       ebx  - vertices
;       ecx  - triangles count
;       edi  - cross_products, must be aligned !!
;       xmm0 - orgin position (light)
;  out: -> computed list pointed by edi
;    must be declared enough mem !!!


.tc        equ [ebp-4]
.t_ptr     equ [ebp-8]
.v_ptr     equ [ebp-12]
.cross_ptr equ [ebp-16]
.orgin     equ [ebp-32]
    push    ebp
    mov     ebp,esp
    sub     esp,64
    and     ebp,-16
    and     edi,-16  ; to be sure
    mov     .tc,ecx
    mov     .t_ptr,esi
    mov     .v_ptr,ebx
    movaps  .orgin,xmm0

  .Ioop:
    movzx   eax,word[esi]
    movzx   ebx,word[esi+2]
    movzx   edx,word[esi+6]
    shl     eax,2
    shl     ebx,2
    shl     edx,2
    lea     eax,[eax*3]
    lea     ebx,[ebx*3]
    lea     edx,[edx*3]
    add     eax,.v_ptr
    add     ebx,.v_ptr
    add     edx,.v_ptr

    movups  xmm5,[eax]
    movups  xmm6,[ebx]
    movups  xmm7,[edx]
    andps   xmm5,[zero_hgst_dd]
    andps   xmm6,[zero_hgst_dd]
    andps   xmm7,[zero_hgst_dd]
    subps   xmm5,.orgin
    subps   xmm6,.orgin
    subps   xmm7,.orgin

    movaps  xmm0,xmm5
    movaps  xmm2,xmm7
    cross   ; v1 x v3
    movaps  [edi],xmm0

    movaps  xmm0,xmm5
    movaps  xmm2,xmm6
    cross   ; v1 x v2
    movaps  [edi+16],xmm0

    movaps  xmm0,xmm6
    movaps  xmm2,xmm7
    cross   ; v2 x v3
    movaps  [edi+32],xmm0



    add     edi,48
    add     esi,6
    sub     ecx,1
    jnz     .Ioop


    add     esp,64
    pop     ebp
ret


SeguraFeitoRayTriangleIntersect:
; without pre calculations
;  in:
;     xmm0 - origin vertex  (light)  ; ray start
;     xmm1 - ray direction vector    ; ray end
;     xmm2 - vertex 0
;     xmm3 - vertex 1
;     xmm4 - vertex 2
;     xmm5 - normalized triangle normal
;  out:
;     eax = 1 - yes ray intersect triangle
;     eax = 0 - no intersection occur

    .vec0   equ [ebp-16]
    .vec1   equ [ebp-32]
    .vec2   equ [ebp-48]
    .normal equ [ebp-64]
    .origin equ [ebp-80]
    .dir    equ [ebp-96]
    .d      equ [ebp-112]
    .t      equ [ebp-128]
    .p      equ [ebp-144]
    .edge0  equ [ebp-160]
    .edge1  equ [ebp-176]
    .edge2  equ [ebp-192]
    .vp0    equ [ebp-208]
    .vp1    equ [ebp-224]
    .vp2    equ [ebp-240]


  push     ebp
  mov      ebp,esp
  sub      ebp,16
  sub      esp,256
  and      ebp,0xfffffff0

  movaps   .vec0,xmm2
  movaps   .vec1,xmm3
  movaps   .vec2,xmm4
  movaps   .normal,xmm5
  movaps   .origin,xmm0   ; rs
  movaps   .dir,xmm1      ; re

  andps    xmm1,[zero_hgst_dd]
  movaps   xmm5,xmm1
  mulps    xmm5,xmm5
  haddps   xmm5,xmm5
  haddps   xmm5,xmm5
  rsqrtps  xmm5,xmm5
  mulps    xmm1,xmm5

  mulps    xmm1,.normal
  haddps   xmm1,xmm1
  haddps   xmm1,xmm1
  andps    xmm1,[abs_mask]
  cmpnltss xmm1,[epsilon]
  movd     eax,xmm1
  or       eax,eax   ; direction and normal are parallel (prependicular)
  jz       .end

  movaps   xmm1,.dir

  mulps    xmm2,.normal
  haddps   xmm2,xmm2
  haddps   xmm2,xmm2       ; xmm2 = d = n dot v0
  mulps    xmm0,.normal
  haddps   xmm0,xmm0
  haddps   xmm0,xmm0       ; xmm0 = n dot origin

  addss    xmm2,xmm0
  mulps    xmm1,.normal
  haddps   xmm1,xmm1
  haddps   xmm1,xmm1
  rcpps    xmm1,xmm1
  mulps    xmm2,xmm1       ; xmm2 = t
  movaps   .t,xmm2
  cmpnltss xmm2,[the_zero]
  movd     eax,xmm2
  or       eax,eax
  jz       .end

  movaps   xmm0,.dir
  mulps    xmm0,.t
  addps    xmm0,.origin    ; xmm0 = P
  movaps   .p,xmm0

  movaps   xmm0,.vec1
  subps    xmm0,.vec0      ; xmm0 = edge0
  movaps   xmm2,.p
  subps    xmm2,.vec0
  mulps    xmm2,.normal    ; xmm2 = vp1

  cross
                          ; xmm0 - cross pr
  mulps    xmm0,.normal
  haddps   xmm0,xmm0
  haddps   xmm0,xmm0
  cmpnltss xmm0,[the_zero]
  movd     eax,xmm0
  or       eax,eax
  jz       .end             ; P is on the right side




  movaps   xmm0,.vec2
  subps    xmm0,.vec1      ; xmm0 = edge1
  movaps   xmm2,.p
  subps    xmm2,.vec1
  mulps    xmm2,.normal    ; xmm2 = vp2

  cross
                          ; xmm0 - cross pr
  mulps    xmm0,.normal
  haddps   xmm0,xmm0
  haddps   xmm0,xmm0
  cmpnltss xmm0,[the_zero]
  movd     eax,xmm0
  or       eax,eax
  jz       .end            ; P is on the right side



  movaps   xmm0,.vec0
  subps    xmm0,.vec2      ; xmm0 = edge2
  movaps   xmm2,.p
  subps    xmm2,.vec2
  mulps    xmm2,.normal    ; xmm2 = vp3

  cross
                          ; xmm0 - cross pr
  mulps    xmm0,.normal
  haddps   xmm0,xmm0
  haddps   xmm0,xmm0
  cmpnltss xmm0,[the_zero]
  movd     eax,xmm0
  or       eax,eax
  jz       .end            ; P is on the right side


  mov      eax,1  ; this ray hits the triangle


.end:
  add      esp,256
  pop      ebp
ret





SeguraFeitoRayTriangleIntersect2:
; without pre calculations
;  in:
;     xmm0 - origin vertex  (light)  ; ray start
;     xmm1 - ray direction vector    ; ray end
;     xmm2 - vertex 1
;     xmm3 - vertex 2
;     xmm4 - vertex 3
;  out:
;     eax = 1 - yes, ray intersect triangle
;     eax = 0 - no intersection occur

    .vec1   equ [ebp-16]
    .vec2   equ [ebp-32]
    .vec3   equ [ebp-48]
 ;   .normal equ [ebp-64]
    .origin equ [ebp-80]
    .dir    equ [ebp-96]
    .v1xv3  equ [ebp-112]
    .v1xv2  equ [ebp-128]
    .v2xv3  equ [ebp-144]


  push     ebp
  mov      ebp,esp
  sub      ebp,16
  sub      esp,256
  and      ebp,0xfffffff0

  movaps   .vec1,xmm2
  movaps   .vec2,xmm3
  movaps   .vec3,xmm4
  movaps   .origin,xmm0   ; rs
  movaps   .dir,xmm1      ; re
;  int3
  movaps   xmm0,.vec1
  subps    xmm0,.orgin
  movaps   xmm2,.vec3
  subps    xmm2,.orgin
  cross
  andps    xmm0,[zero_hgst_dd]
  movaps   xmm1,xmm0
  mulps    xmm0,xmm0
  haddps   xmm0,xmm0
  haddps   xmm0,xmm0
  rsqrtps  xmm0,xmm0
  mulps    xmm0,xmm1
  movaps   .v1xv3,xmm0   ; normalized cross product

  movaps   xmm0,.vec1
  subps    xmm0,.orgin
  movaps   xmm2,.vec2
  subps    xmm2,.orgin
  cross
  andps    xmm0,[zero_hgst_dd]
  movaps   xmm1,xmm0
  mulps    xmm0,xmm0
  haddps   xmm0,xmm0
  haddps   xmm0,xmm0
  rsqrtps  xmm0,xmm0
  mulps    xmm0,xmm1
  movaps   .v1xv2,xmm0   ; normalized cross product

  movaps   xmm0,.vec2
  subps    xmm0,.orgin
  movaps   xmm2,.vec3
  subps    xmm2,.orgin
  cross
  andps    xmm0,[zero_hgst_dd]
  movaps   xmm1,xmm0
  mulps    xmm0,xmm0
  haddps   xmm0,xmm0
  haddps   xmm0,xmm0
  rsqrtps  xmm0,xmm0
  mulps    xmm0,xmm1
  movaps   .v2xv3,xmm0  ; normalized cross product

  movaps   xmm0,.dir
;  andps    xmm0,[zero_hgst_dd]
;  movaps   xmm1,xmm0
;  mulps    xmm0,xmm0
;  haddps   xmm0,xmm0
;  haddps   xmm0,xmm0
;  rsqrtps  xmm0,xmm0
;  mulps    xmm0,xmm1    ; normalized light direction vector
;  movaps   .dir,xmm0
;  int3
  mulps     xmm0,.v1xv3
  haddps    xmm0,xmm0
  haddps    xmm0,xmm0
  cmpless   xmm0,[the_zero]
  movd      eax,xmm0
  or        eax,eax
  jz        .end

  movaps   xmm0,.dir
  mulps    xmm0,.v1xv2
  haddps   xmm0,xmm0
  haddps   xmm0,xmm0
  cmpless  xmm0,[the_zero]
  movd     eax,xmm0
  or       eax,eax
  jz       .end

  movaps   xmm0,.dir
  mulps    xmm0,.v2xv3
  haddps   xmm0,xmm0
  haddps   xmm0,xmm0
  cmpless  xmm0,[the_zero]
  movd     eax,xmm0
  or       eax,eax
  jz       .end

  mov      eax,1  ; yes, ray intersect triangle
;  jmp      .end1
.end:
;   not      eax
;.end1:

  add      esp,256
  pop      ebp
ret




if 0

Check_point_in_shadow:
; Procedure check if the current point (pixel) is in shadow.
; Proc return 0 if ray from cur pixel to light source not
; intersect any plane. Otherwise, return number of light.
; Max light count - 4, Example return value -
; - eax= 0 + 1 shl 8 + 2 shl 16 + 0 shl 24 + 0 shl 32
; It means lights '1' and '2' not participate in lighting of
; current pixel.
;in:
; esi - triangles list
; edi - triangles normals list
; eax - vertices list
; ebx - count of vertices
; ecx - count of triangles
end if


; Ray traced shadows by Maciej Guba.
; http://macgub.vxm.pl, macgub3@wp.pl


Check_point_in_shadow:
; only one light version
; in:
;     xmm0 - lo -> hi dword integer vert_cnt, tri_cnt, vert_ptr, tri_ptr
;     xmm1 - current point cooridinates (x,y,z), should be interpolated
;     xmm2 - normalized light vector
;     xmm3 - light position (vertex)
;     esi  - triangles normals pointer
; out:
;    eax = 0 -> point not in shadow, eax = 1 -> point in shadow
 .tri_ptr   equ [ebp-4]
 .vert_ptr  equ [ebp-8]
 .tri_cnt   equ [ebp-12]
 .vert_cnt  equ [ebp-16]
 .coords    equ [ebp-32]
 .l_v       equ [ebp-48]
 .l_pos     equ [ebp-64]
 .t_norm_ptr equ  [ebp-68]
   push    ebp
   mov     ebp,esp
   sub     ebp,16
   sub     esp,128
   and     ebp,-16
   movdqa  .vert_cnt,xmm0
   movaps  .coords,xmm1
   andps   xmm2,[zero_hgst_dd]
   andps   xmm3,[zero_hgst_dd]
   movaps  .l_v,xmm2
   movaps  .l_pos,xmm3

   mov    ecx,.tri_cnt
   mov    esi,.tri_ptr
 .again:
   push   ecx
   push   esi
   movzx  eax,word[esi]
   movzx  ebx,word[esi+2]
   movzx  edx,word[esi+4]
   imul   eax,[i12]
   imul   ebx,[i12]
   imul   ecx,[i12]
   add    eax,.vert_ptr
   add    ebx,.vert_ptr
   add    edx,.vert_ptr
   movaps xmm0,.l_pos
   movaps xmm1,.l_v
   movups xmm2,[eax]
   movups xmm3,[ebx]
   movups xmm4,[edx]
   andps  xmm2,[zero_hgst_dd]
   andps  xmm3,[zero_hgst_dd]
   andps  xmm4,[zero_hgst_dd]

   call   SeguraFeitoRayTriangleIntersect2


   pop    esi
   pop    ecx

   cmp     eax,0
   jne     .end     ; yes ray intersect triangle
                    ; break (because) only one light

   add    esi,6
   sub    ecx,1
   jnz    .again

   xor   eax,eax   ; ray not intersect any triangle
 .end:
   add   esp,128
   pop   ebp
ret

ROUND2 equ 10
RayShadowRealPhg_tri:
;----"Real Phong + raytraced shadows"--------------------
;----Procedure renders triangle with point light(s) and -
;---- ray traced shadows mixed with z buffer alogorithm.-
;-------in:  eax - x1 shl 16 + y1 -----------------------
;----------- ebx - x2 shl 16 + y2 -----------------------
;----------- ecx - x3 shl 16 + y3 -----------------------
;----------- edx - --------------------------------------
;----------- esi - pointer to Z-buffer filled with ------
;-----------       dword float variables-----------------
;----------- edi - pointer to screen buffer--------------
;----------- xmm0 - 1st normal vector -------------------
;----------- xmm1 - 2cond normal vector -----------------
;----------- xmm2 - 3rd normal vector -------------------
;----------- xmm3 - light position as dword float x,y,z -
;-----------        translated into 'screen' coorinates -
;----------- xmm4 - lo -> hi z1, z2, z3 coords as -------
;-----------        dwords floats -----------------------
;----------- xmm5 - lo -> hi y_min, y_max, x_min,--------
;-----------        x_max as dword integers -------------
;----------- xmm6 - -------------------------------------
;----------- mm0 - pointer to triangles list ------------
;----------- mm1 - pointer to points (vertices) list-----
;----------- mm2 - triangles count ----------------------
;----------- mm3 - vertices count -----------------------
;---------------------- stack - no parameters -----------
;--------------------------------------------------------
;----------------- procedure don't save registers !! ----




  push  ebp
  mov   ebp,esp
  sub   esp,512
  sub   ebp,16
  and   ebp,0xfffffff0

  .1_nv equ [ebp-16]
  .2_nv equ [ebp-32]
  .3_nv equ [ebp-48]
  .l_ps equ [ebp-64]
  .z3   equ [ebp-72]
  .z2   equ [ebp-76]
  .z1   equ [ebp-80]
  .x1   equ [ebp-82]
  .y1   equ [ebp-84]
  .x2   equ [ebp-86]
  .y2   equ [ebp-88]
  .x3   equ [ebp-90]
  .y3   equ [ebp-92]
  .Zbuf equ [ebp-96]
  .x_max  equ  [ebp-100]
  .x_min  equ  [ebp-104]
  .y_max  equ  [ebp-108]
  .y_min  equ  [ebp-112]
  .screen equ  [ebp-116]
  .dx12   equ  [ebp-120]
  .dx13   equ  [ebp-124]
  .dx23   equ  [ebp-128]
  .dn12   equ  [ebp-144]
  .dn13   equ  [ebp-160]
  .dn23   equ  [ebp-176]
  .dz12   equ  [ebp-180]
  .dz13   equ  [ebp-184]
  .dz23   equ  [ebp-188]

  .cnv1     equ [ebp-208]  ; cur normal vectors
  .cnv2     equ [ebp-224]
  .cz2      equ [ebp-228]
  .cz1      equ [ebp-232]
  .tri_ptr  equ [ebp-244]
  .vert_ptr equ [ebp-248]
  .tri_cnt  equ [ebp-252]
  .vert_cnt equ [ebp-256]



 .sort3:                  ; sort triangle coordinates...
       cmp     ax,bx
       jle     .sort1
       xchg    eax,ebx
       shufps  xmm4,xmm4,11100001b
       movaps  xmm6,xmm0
       movaps  xmm0,xmm1
       movaps  xmm1,xmm6


 .sort1:
       cmp      bx,cx
       jle      .sort2
       xchg     ebx,ecx
       shufps   xmm4,xmm4,11011000b
       movaps   xmm6,xmm1
       movaps   xmm1,xmm2
       movaps   xmm2,xmm6

       jmp .sort3

 .sort2:

   movaps .z1,xmm4
   mov    .y1,eax
   mov    .y2,ebx
   mov    .y3,ecx
   movdqa   .y_min,xmm5

if 1                            ; check if at last only fragment
   packssdw xmm5,xmm5       ; of triangle is in visable area
   pshuflw  xmm5,xmm5,11011000b
   movdqu   xmm7,.y3
   movdqa   xmm6,xmm5
   pshufd   xmm5,xmm5,0  ; xmm5 lo-hi -> broadcasted y_min, x_min
   pshufd   xmm6,xmm6,01010101b ;xmm6 -> brd y_max x_max
   movdqa   xmm4,xmm7
   pcmpgtw  xmm7,xmm5
   pcmpgtw  xmm4,xmm6
   pxor     xmm7,xmm4
   pmovmskb eax,xmm7
   and      eax,0x00aaaaaa
   or       eax,eax
   jz       .rpt_loop2_end
end if
   movaps   .1_nv,xmm0
   movaps   .2_nv,xmm1
   movaps   .3_nv,xmm2
   movaps   .l_ps,xmm3
   mov      .Zbuf,esi
   mov      .screen,edi
   movd     .tri_ptr,mm0
   movd     .vert_ptr,mm1
   movd     .tri_cnt,mm2
   movd     .vert_cnt,mm3


       mov      bx,.y2       ; calc deltas
       sub      bx,.y1
       jnz      .rpt_dx12_make

       xorps    xmm7,xmm7
       mov      dword .dx12,0
       mov      dword .dz12,0
       movaps   .dn12,xmm7
       jmp      .rpt_dx12_done

  .rpt_dx12_make:
       mov      ax,.x2
       sub      ax,.x1
       cwde
       movsx    ebx,bx
       shl      eax,ROUND2
       cdq
       idiv     ebx
       mov      .dx12,eax

       cvtsi2ss xmm6,ebx
       movss    xmm5,.z2
       subss    xmm5,.z1
       divss    xmm5,xmm6
       movss    .dz12,xmm5

       movaps   xmm0,.2_nv
       subps    xmm0,.1_nv
       shufps   xmm6,xmm6,0
       divps    xmm0,xmm6
       movaps   .dn12,xmm0


   .rpt_dx12_done:

       mov      bx,.y3       ; calc deltas
       sub      bx,.y1
       jnz      .rpt_dx13_make

       xorps    xmm7,xmm7
       mov      dword .dx13,0
       mov      dword .dz13,0
       movaps   .dn13,xmm7
       jmp      .rpt_dx13_done

  .rpt_dx13_make:
       mov      ax,.x3
       sub      ax,.x1
       cwde
       movsx    ebx,bx
       shl      eax,ROUND2
       cdq
       idiv     ebx
       mov      .dx13,eax

       cvtsi2ss xmm6,ebx
       movss    xmm5,.z3
       subss    xmm5,.z1
       divss    xmm5,xmm6
       movss    .dz13,xmm5

       movaps   xmm0,.3_nv
       subps    xmm0,.1_nv
       shufps   xmm6,xmm6,0
       divps    xmm0,xmm6
       movaps   .dn13,xmm0

   .rpt_dx13_done:

       mov      bx,.y3       ; calc deltas
       sub      bx,.y2
       jnz      .rpt_dx23_make

       xorps    xmm7,xmm7
       mov      dword .dx23,0
       mov      dword .dz23,0
       movaps   .dn23,xmm7
       jmp      .rpt_dx23_done

  .rpt_dx23_make:
       mov      ax,.x3
       sub      ax,.x2
       cwde
       movsx    ebx,bx
       shl      eax,ROUND2
       cdq
       idiv     ebx
       mov      .dx23,eax

       cvtsi2ss xmm6,ebx
       movss    xmm5,.z3
       subss    xmm5,.z2
       divss    xmm5,xmm6
       movss    .dz23,xmm5

       movaps   xmm0,.3_nv
       subps    xmm0,.2_nv
       shufps   xmm6,xmm6,0
       divps    xmm0,xmm6
       movaps   .dn23,xmm0

   .rpt_dx23_done:


       movsx   eax,word .x1
       shl     eax,ROUND2
       mov     ebx,eax
       mov     edx,.z1
       mov     .cz1,edx
       mov     .cz2,edx
       movaps  xmm0,.1_nv
       movaps  .cnv1,xmm0
       movaps  .cnv2,xmm0
       mov     edi,.screen
       mov     esi,.Zbuf


       movsx    ecx,word .y1
       cmp      cx,.y2

       jge      .rpt_loop1_end

    .rpt_loop1:
       pushad

       movaps   xmm2,.y_min
       movaps   xmm0,.cnv1
       movaps   xmm1,.cnv2
       movlps   xmm3,.cz1
       movaps   xmm4,.l_ps
       sar      ebx,ROUND2
       sar      eax,ROUND2
       movaps   xmm5,.vert_cnt

       call     RayShdPhg_line

       popad
       movaps   xmm0,.cnv1
       movaps   xmm1,.cnv2
       movss    xmm2,.cz1
       movss    xmm3,.cz2
       addps    xmm0,.dn13
       addps    xmm1,.dn12
       addss    xmm2,.dz13
       addss    xmm3,.dz12
       add      eax,.dx13
       add      ebx,.dx12

       movaps   .cnv1,xmm0
       movaps   .cnv2,xmm1
       movss    .cz1,xmm2
       movss    .cz2,xmm3

       add      ecx,1
       cmp      cx,.y2
       jl       .rpt_loop1





   .rpt_loop1_end:
       movsx    ecx,word .y2
       cmp      cx,.y3
       jge      .rpt_loop2_end

       movsx    ebx,word .x2           ; eax - cur x1
       shl      ebx,ROUND2             ; ebx - cur x2
       push     dword .z2
       pop      dword .cz2
       movaps   xmm0,.2_nv
       movaps   .cnv2,xmm0


     .rpt_loop2:
       pushad

       movaps   xmm2,.y_min
       movaps   xmm0,.cnv1
       movaps   xmm1,.cnv2
       movlps   xmm3,.cz1
       movaps   xmm4,.l_ps
       sar      ebx,ROUND2
       sar      eax,ROUND2
;       mov      edi,.screen
;       mov      esi,.Zbuf
       movaps   xmm5,.vert_cnt


       call     RayShdPhg_line

       popad
       movaps   xmm0,.cnv1
       movaps   xmm1,.cnv2
       movss    xmm2,.cz1
       movss    xmm3,.cz2
       addps    xmm0,.dn13
       addps    xmm1,.dn23
       addss    xmm2,.dz13
       addss    xmm3,.dz23
       add      eax,.dx13
       add      ebx,.dx23

       movaps   .cnv1,xmm0
       movaps   .cnv2,xmm1
       movss    .cz1,xmm2
       movss    .cz2,xmm3

       add      ecx,1
       cmp      cx,.y3
       jl       .rpt_loop2

    .rpt_loop2_end:

      add   esp,512
      pop   ebp
ret
align 16
RayShdPhg_line:
; in:
;    xmm0 - normal vector 1
;    xmm1 - normal vect 2
;    xmm3 - lo -> hi z1, z2 coords as dwords floats
;    xmm2 - lo -> hi y_min, y_max, x_min, x_max
;           as dword integers
;    xmm4 - light position as dwords float x,y,z
;    xmm5 - lo -> hi vertices, triangles count, vertices, triangles pointer
;    eax - x1
;    ebx - x2
;    ecx - y
;    edi - screen buffer
;    esi - z buffer

   push  ebp
   mov   ebp,esp
   sub   esp,256
   sub   ebp,16
   and   ebp,0xfffffff0

 .n1     equ [ebp-16]
 .n2     equ [ebp-32]
 .l_pos  equ [ebp-48]
 .lx1    equ [ebp-52]
 .lx2    equ [ebp-56]
 .z2     equ [ebp-60]
 .z1     equ [ebp-64]
 .screen equ [ebp-68]
 .zbuff  equ [ebp-72]
 .x_max  equ [ebp-74]
 .x_min  equ [ebp-76]
 .y_max  equ [ebp-78]
 .y_min  equ [ebp-80]
 .dn     equ [ebp-96]
 .dz     equ [ebp-100]
 .y      equ [ebp-104]
 .cnv    equ [ebp-128]
 .tri_ptr  equ [ebp-132]
 .vert_ptr equ [ebp-136]
 .tri_cnt  equ [ebp-140]
 .vert_cnt equ [ebp-144]
 .cur_z    equ [ebp-152] ; float
 .cur_y    equ [ebp-156] ; float
 .cur_x    equ [ebp-160] ; float
 .l_vec    equ [ebp-176] ; cur light vector
 .col      equ [ebp-192]
 .cur_n    equ [ebp-208]


; .col_sum_b  equ [ebp-136]
; .col_sum_g  equ [ebp-140]
; .col_sum_r  equ [ebp-144]
; .cur_col equ [ebp-160]
; .stencil_buf equ [ebp-164]

        mov    .y,ecx
        packssdw xmm2,xmm2
        movq   .y_min,xmm2
        cmp    cx,.y_min
        jl     .end_rp_line
        cmp    cx,.y_max
        jge    .end_rp_line          ;

        cmp     eax,ebx
        je      .end_rp_line
        jl      @f
        xchg    eax,ebx
        movaps  xmm7,xmm0
        movaps  xmm0,xmm1
        movaps  xmm1,xmm7
        shufps  xmm3,xmm3,11100001b
   @@:

        cmp     ax,.x_max
        jge     .end_rp_line
        cmp     bx,.x_min
        jle     .end_rp_line
        movaps  .lv,xmm4
        movaps  .n1,xmm0
        movaps  .n2,xmm1
        mov     .lx1,eax
        mov     .lx2,ebx
        movlps  .z1,xmm3
        movups  .vert_cnt,xmm5

        sub     ebx,eax
   ;     cvtsi2ss xmm7,eax
   ;     movss    .cur_x,xmm7
        cvtsi2ss xmm7,ebx
        movss   .cur_y,xmm7
        shufps  xmm7,xmm7,0
        subps   xmm1,xmm0
        divps   xmm1,xmm7
        movaps  .dn,xmm1
        psrldq  xmm3,4
        subss   xmm3,.z1
        divss   xmm3,xmm7
        movss   .dz,xmm3



        mov      ebx,.lx1
        cmp      bx,.x_min     ; clipping on function4
        jge      @f
        movzx    eax,word .x_min
        sub      eax,ebx
        cvtsi2ss xmm7,eax
        shufps   xmm7,xmm7,0
        mulss    xmm3,xmm7
        mulps    xmm1,xmm7
        addss    xmm3,.z1
        addps    xmm1,.n1
        movsx    eax,word .x_min
        movss    .z1,xmm3
        movaps   .n1,xmm1
        mov      dword .lx1,eax

      @@:
        movzx   eax,word .x_max
        cmp     .lx2,eax
        jl      @f
        mov     .lx2,eax
      @@:
        movzx   eax,word[xres_var]    ; ugly global
        mul     dword .y


        add     eax,.lx1
        shl     eax,2
        add     edi,eax
        add     esi,eax       ; z buff



        mov     ecx,.lx2
        sub     ecx,.lx1
        cvtsi2ss  xmm1,dword .lx1

   ;
        movaps  xmm0,.n1
        movss   xmm2,.z1
        movss   .cur_x,xmm1
        movss   .cur_z,xmm2
        movaps  .cur_n,xmm0
align 16
   .ddraw:
        movss    xmm7,.cur_z
        cmpnltss xmm7,dword[esi]
        movd     eax,xmm7
        or       eax,eax
        jnz      .skip
        push     dword .cur_z
        pop      dword[esi]

        movaps   xmm7,.cur_n
        mulps    xmm7,xmm7 ; normalize
        haddps   xmm7,xmm7
        haddps   xmm7,xmm7
        rsqrtps  xmm7,xmm7
        mulps    xmm7,.cur_n
        andps    xmm7,[abs_z_coof]  ; calc absolute z coeficient value
      ;  maxps    xmm7,[the_zero]
        movaps   .cnv,xmm7




     ;   mov      eax,255.0
     ;   movd     xmm1,eax
     ;   shufps   xmm1,xmm1,11000000b
        movaps   xmm1,[lights_aligned+16]

        movaps   xmm3,.l_pos
        subps    xmm3,.cur_x      ; calc light vector
        andps    xmm3,[zero_hgst_dd]
        movaps   xmm6,xmm3
        mulps    xmm6,xmm6
        haddps   xmm6,xmm6
        haddps   xmm6,xmm6
        rsqrtps  xmm6,xmm6
        mulps    xmm3,xmm6
        movaps   .l_vec,xmm3



        mulps    xmm3,xmm7
        haddps   xmm3,xmm3
        haddps   xmm3,xmm3
        mulps    xmm1,xmm3



  if 0



        mov      edx,lights_aligned  ; lights_aligned - global variable
        xorps    xmm1,xmm1           ; instead global can be used .lv - light vect.

      .again_col:  ; only one light - one col
        movaps    xmm7,.cnv
        movaps    xmm6,.cur_x    ; calc and normalize light vector
        subps     xmm6,.l_pos
        movps     .l_vec,xmm6
        mulps     xmm6,xmm6
        andps     xmm6,[zero_hgst_dword]
        haddps    xmm6,xmm6
        haddps    xmm6,xmm6
        rsqrtps   xmm6,xmm6

        mulps     xmm7,[edx]
        haddps    xmm7,xmm7
        haddps    xmm7,xmm7
    if 1
        ; stencil
        movss     xmm5,xmm2
        movss     xmm6,xmm2
        addss     xmm5,[aprox]
        subss     xmm6,[aprox]
      ; Stencil buffer for now work as I expected :D
        cmpnltss  xmm5,dword[ebx]
        cmpnltss  xmm6,dword[ebx]
        xorps     xmm5,xmm6
        xorps     xmm6,xmm6
        movd      eax,xmm5
        cmp       eax,-1
        jne       .no_reflective
   end if
     @@:
        movaps    xmm6,xmm7
        mulps     xmm6,xmm6
        mulps     xmm6,xmm6

        mulps     xmm6,xmm6
        mulps     xmm6,[edx+48]
      .no_reflective:
        mulps     xmm7,[edx+16]
        addps     xmm7,xmm6
        addps     xmm7,[edx+32]
        minps     xmm7,[mask_255f]   ; global


        maxps     xmm1,xmm7
        add       edx,64     ; size of one light in aligned list
        cmp       edx,lights_aligned_end
        jl        .again_col
        cvtps2dq  xmm1,xmm1
        movd      xmm6,[edi]
        packssdw  xmm1,xmm1
        packuswb  xmm1,xmm1
        paddusb   xmm1,xmm6
end if
      ; check shadow
      ;     xmm0 - lo -> hi dword integer vert_cnt, tri_cnt, vert_ptr, tri_ptr
;     xmm1 - current point cooridinates (x,y,z), should be interpolated
;     xmm2 - normalized light vector
;     xmm3 - light position (vertex)
        movaps   .col,xmm1
        movaps   xmm0,.vert_cnt
        movaps   xmm1,.cur_x
        movaps   xmm2,.l_vec
        movaps   xmm3,.l_pos
   ;   cmp [bump_flag],1
   ;   je  .sskip    ; test
        push     esi
        push     edi
        push     ecx
        push     ebx
        pushad
        call     Check_point_in_shadow
        mov      [markshd],eax
        popad
        pop      ebx
        pop      ecx
        pop      edi
        pop      esi
   ;   .sskip:
        movaps    xmm1,.col
        cvtps2dq  xmm1,xmm1
        packssdw  xmm1,xmm1
        packuswb  xmm1,xmm1
        movd      [edi],xmm1
   ;     cmp       [bump_flag],1
   ;     je        @f
        cmp       [markshd],0
      ;  cmp       eax,1
        je         @f
        mov       dword[edi],0x00
      @@:
     .skip:
        movaps   xmm0,.cur_n
        movss    xmm1,.cur_x
        movss    xmm2,.cur_z
        add      edi,4
        add      esi,4
        addps    xmm0,.dn
        addss    xmm1,[the_one]   ; global
        addss    xmm2,.dz
        movaps   .cur_n,xmm0
        movss    .cur_x,xmm1
        movss    .cur_z,xmm2
        sub      ecx,1
        jnz      .ddraw

  .end_rp_line:
        add      esp,256
        pop      ebp

ret
