norm_aligned_lv:     ; normalise aligned light vectors
;  in edi -> lights_ptr
;     ecx -> lights count
    @@:
     movaps  xmm0,[edi]
     movaps  xmm1,[edi]
     mulps   xmm1,xmm1
     haddps  xmm1,xmm1
     haddps  xmm1,xmm1
     rsqrtps xmm1,xmm1
     mulps   xmm0,xmm1
     movaps  [edi],xmm0
     add     edi,64
     sub     ecx,1
     jnz     @b
ret



do_edges_list:
; in  ->
;        eax - ptr to edges list in memory (there must be
;              declared enough size of mem)
;        ebx - ptr to faces
;        ecx - faces(triangles) count
;
; out ->
;        desired list, each edge in list as two words - indices
;          two position in vertices list, pointed by [points_r_ptr]
;        ecx - edges count

     push  ebp
     mov   ebp,esp
     sub   esp,32

     .edges_ptr     equ dword[ebp-4]
     .triangles_ptr equ [ebp-8]
     .tri_count     equ [ebp-12]
     .edges_cnt     equ dword[ebp-16]
     .edge_fix      equ dword[ebp-20]

     mov  .edges_ptr,eax
     mov  .triangles_ptr,ebx
     mov  .tri_count,ecx

     mov  .edges_cnt,1
   .next_tri:
     mov  .edge_fix,0
     mov  edx,dword[ebx] ; load edge from triangles list
   .seek:
     mov  ecx,.edges_cnt
     mov  esi,.edges_ptr
   .search_edge:   ; does edge exist in list yet ?
     cmp  edx,[esi]
     je   @f   ; found - edge exist in list
     ror  edx,16
     cmp  edx,[esi]
     je   @f   ; found too
     ror  edx,16
     add  esi,4
     sub  ecx,1
     jnz  .search_edge
     mov  [esi],edx
     add  .edges_cnt,1
    @@:
     add  .edge_fix,1
     cmp  .edge_fix,1
     jz   .ed1
     cmp  .edge_fix,2
     jz   .ed2
     add  ebx,6
     jmp  .next_tri

   .ed1:
     mov  edx,dword[ebx+2] ; load edge from triangles list
     jmp  .seek

   .ed2:
     mov  dx,[ebx]
     shl  edx,16
     mov  dx,[ebx+4]
     sub  dword .tri_count,1
     jnz  .seek

     mov  ecx,.edges_cnt
     sub  ecx,1

     mov  esp,ebp
     pop  ebp
ret
if 0
merge_triangles:    ; remove redundand vertices
; in:
;     registers:
;        eax - approximation tolerancy (as dword float)
;     globals:
;        points_r_ptr, triangles_ptr. points_count_var, triangles_count_var
; out:
;     recomputed vertices (points) and faces (triangles) list
   push ebp
   mov  ebp,esp
   sub  esp,120
   and  ebp,-16


   .new_vertices_ptr     equ dword[ebp-4] ; ptr to new vertices (each have its old index)
   .old_vertices_ptr     equ dword[ebp-8]
   .cnt_new_vert         equ dword[ebp-12]
   .cnt_old_vert         equ word [ebp-16]
   .red_table_ind        equ dword[ebp-20]
   .cur_new_vertices_ptr equ dword[ebp-24] ;ptr of indexes of reedundant vertices
   .cnt_vert             equ word [ebp-26]
   .temp_tri_ptr         equ dword[ebp-30]  ; tri list with one byte pro index
                                            ; for mark purposes
   .aprox_n              equ [ebp-48]
   .cur_n                equ [ebp-64]
   .nearest              equ [ebp-68]
   .nearest_index        equ [ebp-72]
   .mark                 equ [ebp-76]
   .indtri0              equ [ebp-80]
   .indtri1              equ [ebp-84]
   .ed1                  equ [ebp-88]
   .indtri2              equ [ebp-92]
   .ed2                  equ [ebp-96]
   .indtri3              equ [ebp-100]
   .ed3                  equ [ebp-104]
   .edcnt                equ [ebp-108]



    ; set approximation tolerancy
   movd    xmm7,eax
   shufps  xmm7,xmm7,0
   shufps  xmm0,xmm0,0
   movaps  .aprox_n,xmm0

   ; alloc mem for new lists
   movzx   eax,[triangles_count_var]
   mul     [i9]
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
 ;  int3
 @@:
   mov    .temp_tri_ptr,eax


   movzx   eax,[points_count_var]
   mul     [i14]
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  ; int3
 @@:
   mov    .new_vertices_ptr,eax


   movzx   eax,[points_count_var]
   mul     [i14]
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
 ;  int3
 @@:
   mov    .old_vertices_ptr,eax



   mov   esi,[points_r_ptr]
   mov   edi,.old_vertices_ptr
   movzx ecx,[points_count_var]
 @@:
   movups xmm0,[esi]
   movups [edi],xmm0
   mov    word[edi+12],0x0
   add    esi,12
   add    edi,14
   sub    ecx,1
   jnz    @b



   push    .new_vertices_ptr
   pop     .cur_new_vertices_ptr








   xor   ecx,ecx
   push  ecx

   mov   .indtri0,ecx
   imul  ecx,[i6]
   add   ecx,[triangles_ptr]
   movq  mm0,[ecx]

   xor   ebx,ebx
   mov   .edcnt,dword 0       ; edge counter
 .srch:
   push  ebx
   movd  eax,mm0
   mov   ecx,ebx
   imul  ebx,[i6]
   add   ebx,[triangles_ptr]
   cmp   eax,[ebx]
   jne   @f  ; .edge_found ; ecx - index of triangle ; eax - edge
   call  .edge_found
   cmp   .edcnt,3
   jne   @f
   add   esp,4
   jmp   .break_search
 @@:

   ror   eax,16
   cmp   eax,[ebx]
   je    .edge_found  ;
   pshufw mm0,mm0,11011000b
   movd   eax,mm0
   cmp    eax,[ebx]
   jne    @f
   call   .edge_found
   cmp    .edcnt,3
   jne    @f
   add    esp,4
   jmp  .break_search
 @@:



   ror    eax,16
   cmp    eax,[ebx]
   je     .edge_found
   pshufw 11001001b
   movd   eax,mm0
   cmp    eax,[ebx]
   je     .edge_found
   ror    eax,16
   cmp    eax,[ebx]
   jne    @f
   call   .edge_found
   cmp   .edcnt,3
   jne   @f
   add   esp,4
   jmp   .break_search
 @@:


   pop    ebx
   add    ebx,1
   cmp    bx,[triangles_count_var]
   je     .srch    ; look for next triangle


   ; no neighbour triangles




  .edge_found:
    lea  ebx,.indtri1
    mov  edx,.edcnt
    shl  edx,3
    add  ebx,edx
    mov  [ebx],ecx
    mov  [ebx+4],eax
    add  .edcnt,1
    ret


 .break_search:
  ; now we have all 3 indexes of neighbour triangles with shared edge
  ; with triangle0, Also we have 3 edges of this triangle 0











   xor     ecx,ecx
 .next_vert:
   push    ecx
   mov     .cnt_old_vert,cx
   mov     eax,ecx
   imul    eax,[i12]
   add     eax,[points_normals_ptr]
   movups  xmm1,[eax]
   movaps  .cur_n,xmm1
   mov     eax,ecx
   imul    eax,[i12]
   add     eax,[points_r_ptr]
   movups  xmm0,[eax]



 ; find nearest
 ; and similar normal vect
   movaps  xmm1,[big_number]
   movss  .nearest,xmm1
   mov     edx,.new_vertices_ptr
   mov     .mark,dword 0
 .find_nearest:
   cmp     word[edx+12],0xffff
   je      .next_vertt  ; [edx+12] marked if redundant

   movups  xmm1,[edx]
   subps   xmm1,xmm0
   andps   xmm1,[zero_hgst_dd]
   mulps   xmm1,xmm1
   haddps  xmm1,xmm1
   haddps  xmm1,xmm1
   sqrtss  xmm1,xmm1
   movss   xmm6,xmm1
   cmpltss xmm6,.nearest
   movd    eax,xmm6
   or      eax,eax
   jz      .next_vertt

   movzx   eax,cx
   imul    eax,[i12]
   add     eax,[triangles_normals_ptr]
   movups  xmm5,[eax]
   movups  xmm6,[eax]
   addps   xmm5,.aprox_n
   subps   xmm6,.aprox_n
   cmpltps  xmm5,.cur_n
   cmpltps  xmm6,.cur_n
   pxor     xmm5,xmm6
   pmovmskb eax,xmm5
   and     eax,0x00000fff
   cmp     ax,0x0fff
   jne     .next_vertt
   andps   .xmm2,[zero_hgst_dd]
   movss   .nearest,xmm1
   mov     .nearest_index,cx
   mov     .mark, dword 1
 .next_vertt:
   add      edx,14
   add      ecx,1
   cmp      cx,[points_count_var]
   jne      .find_nearest
   cmp      .mark,dword 0
   je       .increase_ind


   mov     word[edx+12],0xffff   ; mark red

  ; renew triangles list
   mov     esi,[triangles_ptr]
   mov     ax,.nearest_index
   xor     ecx,ecx
   movzx   edi,[triangles_count_var]
   lea     edi,[edi*3]
 .next_tri:
   cmp     word[esi],ax
   jne     @f
   push    .cnt_old_vert
   pop     word[esi]
  @@:
   add     esi,2
   add     ecx,1
   cmp     ecx,edi
   jne     .next_tri

 .increase_ind:
   pop     ecx
   add     ecx,1
   cmp     cx,[points_count_var]
   jne     .next_vert       ; look for near and similar normal

;   mov     eax,.cur_new_vertices_ptr
;   movups  [eax],xmm0
;   push    .cnt_old_vert
;   pop     word[eax+12]
;   add     .cur_new_vertices_ptr,14
; .non_vertex:
;   add     ebx,14
;   pop     ecx
;   add     ecx,1
;   cmp     cx,[points_count_var]
;   jne     .next_vert
; w liscie new_vert sa nowe vertexy i ich stary index
; lista triang tez wymaga poprawienia na nowe indexy

; in the list pointed by .new_vertices_ptr are new
; vertices and its old index, list pointed by triangles_ptr need
; renew too, instead old, it will be new indexes
if 1

  movzx ecx,[triangles_count_var]
  lea   ecx,[ecx*3]
  mov   esi,[triangles_ptr]
  mov   edi,.temp_tri_ptr
 @@:
  push  word[esi]
  pop   word[edi]
  mov   byte[edi+2],0
  add   esi,2
  add   edi,3
  sub   ecx,1
  jnz   @b

  mov   esi,.new_vertices_ptr
  mov   .cnt_vert,0
 .next_new_vert:
  movzx eax,word[esi+12]
  cmp   ax,0xffff  ; check if redundant
  je    .skip_vrt
  xor   ecx,ecx
  mov   edx,.temp_tri_ptr
  movzx ebx,[triangles_count_var]
  lea   ebx,[ebx*3]
 .next_index:
  cmp   [edx],ax
  jne   @f
  cmp   byte[edx+2],0  ; was the index previously changed ?
  jne   @f
  push  .cnt_vert
  pop   word[edx]
  mov   byte[edx+2],0xff
 @@:
  add   edx,3
  add   ecx,1
  cmp   ecx,ebx
  jne   .next_index
  add   .cnt_vert,1
 .skip_vrt:
  add   esi,14
  cmp   esi,.cur_new_vertices_ptr
  jle   .next_new_vert

  mov   esi,.temp_tri_ptr   ; save desired data in 'global' list
  mov   edi,[triangles_ptr]
  movzx ecx,[triangles_count_var]
  lea   ecx,[ecx*3]
 @@:
  push  word[esi]
  pop   word[edi]
  add   esi,3
  add   edi,2
  sub   ecx,1
  jnz   @b

;  renew list pointed by [points_r_ptr]
  mov   esi,.new_vertices_ptr
  mov   edi,[points_r_ptr]
  xor   ecx,ecx
  xor   edx,edx
 .again:
  movups   xmm0,[esi]
  cmp      word[esi+12],0xffff
  je       .skip
  movups   [edi],xmm0
  add      edx,1
  add      edi,12
 .skip:
  add      esi,14
  add      ecx,1
  cmp      cx,[points_count_var]
  jnz      .again
  mov      [points_count_var],dx
end if

  invoke  VirtualFree ,.new_vertices_ptr ,0 , MEM_RELEASE
  invoke  VirtualFree ,.old_vertices_ptr ,0 , MEM_RELEASE
  invoke  VirtualFree ,.temp_tri_ptr ,0 , MEM_RELEASE
  add      esp,120
  pop      ebp
ret




merge_triangles1:
; in:
;     registers:
;        eax - approximation tolerancy of triangle vect
;              (as dword float)
;        ebx - vertices list ptr
;        esi - triangles list ptr
;        edi - vertex norm,al vectors ptr
;        ecx - vertices count  - integer
;        edx - triangles count - integer
;        xmm0 -approximation toleranc of normal vector
;               as dwoord float
; out:
;     recomputed vertices (points) and faces (triangles) list
   push ebp
   mov  ebp,esp
   sub  esp,140
   and  ebp,-16

   .new_vertices_ptr     equ dword[ebp-4] ; ptr to new vertices (each have its old index)
   .old_vertices_ptr     equ dword[ebp-8]
   .cnt_new_vert         equ dword[ebp-12]
   .cnt_old_vert         equ dword[ebp-18]
   .red_table_ind        equ dword[ebp-22]
   .cur_new_vertices_ptr equ dword[ebp-26] ;ptr of indexes of redundant vertices
   .cnt_vert             equ word [ebp-30]
   .temp_tri_ptr         equ dword[ebp-34]  ; tri list with one byte pro index
                                            ; for mark purposes
   .triangles_count      equ [ebp-38]
   .vert_count           equ [ebp-42]
   .triangles_ptr        equ [ebp-46]
   .vert_ptr             equ [ebp-50]
   .vert_n_ptr           equ [ebp-54]
   .aprox_n              equ [ebp-80]
   .cur_n                equ [ebp-96]


   mov     .vert_n_ptr,edi
   mov     .vert_ptr,ebx
   mov     .vert_count,ecx
   mov     .triangles_ptr,esi
   mov     .triangles_count,edx
   ; set approximation tolerancy
   movd    xmm7,eax
   shufps  xmm7,xmm7,0
   shufps  xmm0,xmm0,0
   movaps  .aprox_n,xmm0




   ; alloc mem for new lists
   mov     eax,.triangles_count
   mul     [i9]
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
 ;  int3
 @@:
   mov    .temp_tri_ptr,eax


   mov     eax,.vert_count
   mul     [i14]
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  ; int3
 @@:
   mov    .new_vertices_ptr,eax

   mov     eax,.vert_count
   mul     [i14]
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
 ;  int3
 @@:
   mov    .old_vertices_ptr,eax

;   mov     eax,.vert_count
;   mul     [i13]
;   add     eax,65536
;   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
;   or      eax,eax
;   jnz     @f
;   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
; ;  int3
; @@:
;   mov    .old_vert_n_ptr,eax



   mov   esi,.vert_ptr
   mov   edi,.old_vertices_ptr
   mov   ecx,.vert_count
 @@:
   movups xmm0,[esi]
   movups [edi],xmm0
   mov    word[edi+12],0x0
   add    esi,12
   add    edi,14
   sub    ecx,1
   jnz    @b

;   mov   esi,.vert_n_ptr
;   mov   edi,.old_vert_n_ptr
;   mov   ecx,.vert_count
; @@:
;   movups xmm0,[esi]
;   movups [edi],xmm0
;   mov    byte[edi+12],0x0
;   add    esi,12
;   add    edi,13
;   sub    ecx,1
;   jnz    @b



   mov     ebx,.old_vertices_ptr  ;[points_r_ptr]
   xor     ecx,ecx
   push    .new_vertices_ptr
   pop     .cur_new_vertices_ptr


 .next_vert:
   push    ecx
   mov     .cnt_old_vert,ecx
   push    ecx
   imul    ecx,[i12]
   add     ecx,.vert_n_ptr
   movups  xmm1,[ecx]
   movaps  .cur_n,xmm1
   pop     ecx
   movups  xmm0,[ebx]
   cmp     word[ebx+12],0xffff
   je      .non_vertex

   mov     edx,.new_vertices_ptr
   xor     ecx,ecx
 .look_for_red:
   push    ecx
   cmp     word[edx+12],0xffff
   je      .red_not_found  ; [edx+12] marked if redundant
   movaps  xmm1,xmm0
   movaps  xmm6,xmm0
   subps   xmm1,xmm7
   addps   xmm6,xmm7
   movups  xmm2,[edx]
   cmpltps  xmm1,xmm2
   cmpltps  xmm6,xmm2
   pxor     xmm1,xmm6
   pmovmskb eax,xmm1
   and     eax,0x00000fff
   cmp     ax,0x0fff
   jne     .red_not_found  ; redundant vertexr found -> ecx - its index
   ; have redundant and orginal similar normal vector ?
   mov     eax,ecx
   imul    eax,[i12]
   add     eax,.vert_n_ptr
   movups  xmm1,[eax]
   movups  xmm6,[eax]
   addps   xmm1,.aprox_n
   subps   xmm6,.aprox_n
   cmpltps  xmm1,.cur_n
   cmpltps  xmm6,.cur_n
   pxor     xmm1,xmm6
   pmovmskb eax,xmm1
   and     eax,0x00000fff
   cmp     ax,0x0fff
   jne     .red_not_found

   mov     word[edx+12],0xffff   ; mark red

  ; renew triangles list
   mov     esi,.triangles_ptr
   mov     eax,ecx
   xor     ecx,ecx
   mov     edi,.triangles_count
   lea     edi,[edi*3]
 .next:
   cmp     word[esi],ax
   jne     @f
   push    .cnt_old_vert
   pop     word[esi]
  @@:
   add     esi,2
   add     ecx,1
   cmp     ecx,edi
   jne     .next

 .red_not_found:
   pop     ecx
   add     ecx,1
   add     edx,14  ;12
   cmp     cx,.vert_count
   jl      .look_for_red       ; look for redundant

   mov     eax,.cur_new_vertices_ptr
   movups  [eax],xmm0
   push    .cnt_old_vert
   pop     word[eax+12]
   add     .cur_new_vertices_ptr,14
 .non_vertex:
   add     ebx,14
   pop     ecx
   add     ecx,1
   cmp     cx,.vert_count
   jl      .next_vert
; w liscie new_vert sa nowe vertexy i ich stary index
; lista triang tez wymaga poprawienia na nowe indexy

; in the list pointed by .new_vertices_ptr are new
; vertices and its old index, list pointed by triangles_ptr need
; renew too, instead old, it will be new indexes
if 0
  xor     ecx,ecx
@@:
  mov     esi,.new_vertices_ptr  ; .cur
  mov     edi,.vert_ptr
  movups  xmm0,[esi]
  movlps  [edi],xmm0
  movhlps xmm0,xmm0
  movss   [edi],xmm0
  add     esi,14
  add     edi,12
  add     ecx,1
  cmp     ecx,.vert_count
  jnz     @b
end if
if 1

  mov   ecx,.triangles_count
  lea   ecx,[ecx*3]
  mov   esi,.triangles_ptr
  mov   edi,.temp_tri_ptr
 @@:
  push  word[esi]
  pop   word[edi]
  mov   byte[edi+2],0
  add   esi,2
  add   edi,3
  sub   ecx,1
  jnz   @b

  mov   esi,.new_vertices_ptr
  mov   .cnt_vert,0
 .next_new_vert:
  movzx eax,word[esi+12]
  cmp   ax,0xffff  ; check if redundant
  je    .skip_vrt
  xor   ecx,ecx
  mov   edx,.temp_tri_ptr
  mov   ebx,.triangles_count
  lea   ebx,[ebx*3]
 .next_index:
  cmp   [edx],ax
  jne   @f
  cmp   byte[edx+2],0  ; was the index previously changed ?
  jne   @f
  push  .cnt_vert
  pop   word[edx]
  mov   byte[edx+2],0xff
 @@:
  add   edx,3
  add   ecx,1
  cmp   ecx,ebx
  jne   .next_index
  add   .cnt_vert,1
 .skip_vrt:
  add   esi,14
  cmp   esi,.cur_new_vertices_ptr
  jle   .next_new_vert

  mov   esi,.temp_tri_ptr   ; save desired data in 'global' list
  mov   edi,.triangles_ptr
  mov   ecx,.triangles_count
  lea   ecx,[ecx*3]
 @@:
  push  word[esi]
  pop   word[edi]
  add   esi,3
  add   edi,2
  sub   ecx,1
  jnz   @b

;  renew list pointed by [points_r_ptr]
  mov   esi,.new_vertices_ptr
  mov   edi,.vert_ptr
  xor   ecx,ecx
  xor   edx,edx
 .again:
  movups   xmm0,[esi]
  cmp      word[esi+12],0xffff
  je       .skip
  movups   [edi],xmm0
  add      edx,1
  add      edi,12
 .skip:
  add      esi,14
  add      ecx,1
  cmp      ecx,.vert_count
  jnz      .again
 ; mov      [points_count_var],dx ; !!!
;  !!!
;  !!!
;  !!!    out edx - new points count var
;  !!!
;  !!!
end if
  push    dx
  invoke  VirtualFree ,.new_vertices_ptr ,0 , MEM_RELEASE
  invoke  VirtualFree ,.old_vertices_ptr ,0 , MEM_RELEASE
  invoke  VirtualFree ,.temp_tri_ptr ,0 , MEM_RELEASE
  pop     dx
  add     esp,140
  pop     ebp
  ; after procs recalc normals vectors
ret
end if
remove_redundant_vert:    ; remove redundand vertices
; in:
;     registers:
;        eax - approximation tolerancy (as dword float)
;     globals:
;        points_r_ptr, triangles_ptr. points_count_var, triangles_count_var
; out:
;     recomputed vertices (points) and faces (triangles) list
   push ebp
   mov  ebp,esp
   sub  esp,64

   .new_vertices_ptr     equ dword[ebp-4] ; ptr to new vertices (each have its old index)
   .old_vertices_ptr     equ dword[ebp-8]
   .cnt_new_vert         equ dword[ebp-12]
   .cnt_old_vert         equ word [ebp-16]
   .red_table_ind        equ dword[ebp-20]
   .cur_new_vertices_ptr equ dword[ebp-24] ;ptr of indexes of reedundant vertices
   .cnt_vert             equ word [ebp-26]
   .temp_tri_ptr         equ dword[ebp-30]  ; tri list with one byte pro index
                                            ; for mark purposes
    ; set approximation tolerancy
   movd    xmm7,eax
   shufps  xmm7,xmm7,0

   ; alloc mem for new lists
   movzx   eax,[triangles_count_var]
   mul     [i9]
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
 ;  int3
 @@:
   mov    .temp_tri_ptr,eax


   movzx   eax,[points_count_var]
   mul     [i14]
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  ; int3
 @@:
   mov    .new_vertices_ptr,eax


   movzx   eax,[points_count_var]
   mul     [i14]
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
 ;  int3
 @@:
   mov    .old_vertices_ptr,eax



   mov   esi,[points_r_ptr]
   mov   edi,.old_vertices_ptr
   movzx ecx,[points_count_var]
 @@:
   movups xmm0,[esi]
   movups [edi],xmm0
   mov    word[edi+12],0x0
   add    esi,12
   add    edi,14
   sub    ecx,1
   jnz    @b


   mov     ebx,.old_vertices_ptr  ;[points_r_ptr]
   xor     ecx,ecx
   push    .new_vertices_ptr
   pop     .cur_new_vertices_ptr


 .next_vert:
   push    ecx
   mov     .cnt_old_vert,cx
   movups  xmm0,[ebx]
   cmp     word[ebx+12],0xffff
   je      .non_vertex

   mov     edx,.new_vertices_ptr
   xor     ecx,ecx
 .look_for_red:
   push    ecx
   cmp     word[edx+12],0xffff
   je      .red_not_found  ; [edx+12] marked if redundant
   movaps  xmm1,xmm0
   movaps  xmm6,xmm0
   subps   xmm1,xmm7
   addps   xmm6,xmm7
   movups  xmm2,[edx]
   cmpltps  xmm1,xmm2
   cmpltps  xmm6,xmm2
   pxor     xmm1,xmm6
   pmovmskb eax,xmm1
   and     eax,0x00000fff
   cmp     ax,0x0fff
   jne     .red_not_found  ; redundant vetexr found -> ecx - its index

   mov     word[edx+12],0xffff   ; mark red

  ; renew triangles list
   mov     esi,[triangles_ptr]
   mov     ax,cx
   xor     ecx,ecx
   movzx   edi,[triangles_count_var]
   lea     edi,[edi*3]
 .next:
   cmp     word[esi],ax
   jne     @f
   push    .cnt_old_vert
   pop     word[esi]
  @@:
   add     esi,2
   add     ecx,1
   cmp     ecx,edi
   jne     .next

 .red_not_found:
   pop     ecx
   add     ecx,1
   add     edx,14  ;12
   cmp     cx,[points_count_var]
   jne     .look_for_red       ; look for redundant

   mov     eax,.cur_new_vertices_ptr
   movups  [eax],xmm0
   push    .cnt_old_vert
   pop     word[eax+12]
   add     .cur_new_vertices_ptr,14
 .non_vertex:
   add     ebx,14
   pop     ecx
   add     ecx,1
   cmp     cx,[points_count_var]
   jne     .next_vert
; w liscie new_vert sa nowe vertexy i ich stary index
; lista triang tez wymaga poprawienia na nowe indexy

; in the list pointed by .new_vertices_ptr are new
; vertices and its old index, list pointed by triangles_ptr need
; renew too, instead old, it will be new indexes
if 0
  xor     ecx,ecx
@@:
  mov     esi,.new_vertices_ptr  ; .cur
  mov     edi,[points_r_ptr]
  movups  xmm0,[esi]
  movlps  [edi],xmm0
  movhlps xmm0,xmm0
  movss   [edi],xmm0
  add     esi,14
  add     edi,12
  add     ecx,1
  cmp     cx,[points_count_var]
  jnz     @b
end if
if 1

  movzx ecx,[triangles_count_var]
  lea   ecx,[ecx*3]
  mov   esi,[triangles_ptr]
  mov   edi,.temp_tri_ptr
 @@:
  push  word[esi]
  pop   word[edi]
  mov   byte[edi+2],0
  add   esi,2
  add   edi,3
  sub   ecx,1
  jnz   @b

  mov   esi,.new_vertices_ptr
  mov   .cnt_vert,0
 .next_new_vert:
  movzx eax,word[esi+12]
  cmp   ax,0xffff  ; check if redundant
  je    .skip_vrt
  xor   ecx,ecx
  mov   edx,.temp_tri_ptr
  movzx ebx,[triangles_count_var]
  lea   ebx,[ebx*3]
 .next_index:
  cmp   [edx],ax
  jne   @f
  cmp   byte[edx+2],0  ; was the index previously changed ?
  jne   @f
  push  .cnt_vert
  pop   word[edx]
  mov   byte[edx+2],0xff
 @@:
  add   edx,3
  add   ecx,1
  cmp   ecx,ebx
  jne   .next_index
  add   .cnt_vert,1
 .skip_vrt:
  add   esi,14
  cmp   esi,.cur_new_vertices_ptr
  jle   .next_new_vert

  mov   esi,.temp_tri_ptr   ; save desired data in 'global' list
  mov   edi,[triangles_ptr]
  movzx ecx,[triangles_count_var]
  lea   ecx,[ecx*3]
 @@:
  push  word[esi]
  pop   word[edi]
  add   esi,3
  add   edi,2
  sub   ecx,1
  jnz   @b

;  renew list pointed by [points_r_ptr]
  mov   esi,.new_vertices_ptr
  mov   edi,[points_r_ptr]
  xor   ecx,ecx
  xor   edx,edx
 .again:
  movups   xmm0,[esi]
  cmp      word[esi+12],0xffff
  je       .skip
  movups   [edi],xmm0
  add      edx,1
  add      edi,12
 .skip:
  add      esi,14
  add      ecx,1
  cmp      cx,[points_count_var]
  jnz      .again
  mov      [points_count_var],dx
end if

  invoke  VirtualFree ,.new_vertices_ptr ,0 , MEM_RELEASE
  invoke  VirtualFree ,.old_vertices_ptr ,0 , MEM_RELEASE
  invoke  VirtualFree ,.temp_tri_ptr ,0 , MEM_RELEASE
  mov      esp,ebp
  pop      ebp
ret

set_triangulize_rect:
; in eax - coords y shl 16 + x
        movd      xmm0,eax
        pxor      xmm1,xmm1
        punpcklwd xmm0,xmm1
        cvtdq2ps  xmm0,xmm0
        cmp      [edit_tri_area],2; cx,65535
        jnz    @f
        movlps    qword[tri_area_x1],xmm0
        jmp       .end
     @@:
        cmp     [edit_tri_area],1  ; cx,65534
        jnz    .end
        movlps    qword[tri_area_x2],xmm0
  .end:
ret
if 0
draw_curve_derives:
;in esi - derives list
;   edi - screen buffer
;   eax -
     push  ebp
     mov   ebp,esp
     sub   esp,32

     .d_lst  equ [ebp-4]






end if

draw_triangulize_rect:
    movups    xmm0,dqword[tri_area_x1]
    cvtps2dq  xmm0,xmm0
    shufps    xmm0,xmm0,11011000b
    packssdw  xmm0,xmm0
    movd      eax,xmm0
    psrldq    xmm0,4
    movd      ebx,xmm0

    movd     mm1,[screen_ptr]
   ;  movd     mm0,[Zbuffer_ptr]
    movzx    ecx,[xres_var]
    movd     mm2,ecx
    mov      ecx,0x0000ff00
    movd     mm3,ecx





  ;  push      [screen_ptr]
  ;  pop       [lbuffer_ptr]
  ;  movzx     ecx,[xres_var]
  ;  mov       [screen_width_var],ecx
  ;  mov       [line_color],0x0000ff00




    call      write_frame
    mov       ecx,65533
    movlps    xmm0,qword[tri_area_x1]
    movzx     edx,[xres_var]
    sub       edx,4
    movzx     esi,[yres_var]
    sub       esi,4
    call      bar_edge

    mov       ecx,65532
    movlps    xmm0,qword[tri_area_x2]
    movzx     edx,[xres_var]
    sub       edx,4
    movzx     esi,[yres_var]
    sub       esi,4
    call      bar_edge
ret

fill_aligned:
;in  eax - dword value to fill,
;    ecx - area size in dwords
;    edi - mem adress
;    addres must be aligned
    mov  ebx,ecx
    and  ebx,1111b  ;
    jz   .fill_sse
  @@:
    mov  [edi],eax
    add  edi,4
    sub  ebx,1
    jnz  @b
  .fill_sse:
    shr    ecx,4
    or     ecx,ecx
    jz     .end
    movd   xmm0,eax
    shufps xmm0,xmm0,0
    movaps xmm1,xmm0
    movaps xmm2,xmm0
    movaps xmm3,xmm0
    and    edi,-16 ; to be sure
  @@:
    movaps  [edi],xmm0
    movaps  [edi+16],xmm1
    movaps  [edi+32],xmm2
    movaps  [edi+48],xmm3
    add     edi,64
    sub     ecx,1
    jnz     @b
  .end:
ret

normalize_plane_equation:
 movups xmm0,[plane_equation]    ;normalize
 movaps xmm1,xmm0
; andps  xmm0,[zero_hgst_dd]
 mulps  xmm0,xmm0
 haddps xmm0,xmm0
 haddps xmm0,xmm0
; shufps xmm0,xmm0,00000000b
 rsqrtps xmm0,xmm0
 mulps  xmm1,xmm0     ; xmm1 - normalized plane equat.
 movups [plane_equation],xmm1
ret


calc_shadow:  ; calc shadow 4X4 matrix
 ; in esi -> light vector - ptr to 3 dwords float
 ;    ebx -> ptr to 4x4 shadow matrix 16 dwords, 64 bytes
 movups xmm1,[plane_equation]
 movups xmm0,[esi]
 andps  xmm0,[zero_hgst_dd]
 orps   xmm0,[one_hgst_dd]
 movaps xmm2,xmm0  ; xmm2 light vector
 mulps  xmm0,xmm1
 haddps xmm0,xmm0
 haddps xmm0,xmm0
 movaps xmm4,xmm0  ; xmm4 - dot product

 ; do 4x4 shadow matrix
if 1
 movss  xmm3,[plane_equation]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx],xmm3
 addss  xmm3,xmm4
 movss  [ebx],xmm3

 movss  xmm3,[plane_equation+4]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx+16],xmm3
 shufps xmm3,xmm3,11100001b
 addss  xmm3,xmm4
 movss  [ebx+20],xmm3

 movss  xmm3,[plane_equation+8]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx+32],xmm3
 shufps xmm3,xmm3,11000110b
 addss  xmm3,xmm4
 movss  [ebx+40],xmm3

 movss  xmm3,[plane_equation+12]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx+48],xmm3
 shufps xmm3,xmm3,00100111b
 addss  xmm3,xmm4
 movss  [ebx+60],xmm3      ; finaly matrix done
end if
if 0
 movss  xmm3,[esi]  ;plane_equation]
; andps  xmm3,[zero_hgst_dd]
; orps   xmm3,[one_hgst_dd]
 movups  xmm2,[plane_equation]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx],xmm3
 addss  xmm3,xmm4
 movss  [ebx],xmm3

 movss  xmm3,[esi+4] ;[plane_equation+4]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx+16],xmm3
 shufps xmm3,xmm3,11100001b
 addss  xmm3,xmm4
 movss  [ebx+20],xmm3

 movss  xmm3,[esi+8] ;[plane_equation+8]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx+32],xmm3
 shufps xmm3,xmm3,11000110b
 addss  xmm3,xmm4
 movss  [ebx+40],xmm3

 ;movss  xmm3,[f1]  ;;ation+12]
 ;shufps xmm3,xmm3,0
 ;mulps  xmm3,xmm2
 movups [ebx+48],xmm2
 shufps xmm2,xmm2,00100111b
 addss  xmm2,xmm4
 movss  [ebx+60],xmm2      ; finaly matrix done
end if


ret
if 0
calc_p_light_coords:
; in   - none
; out  - xmm1 -> light position
; uses - edx, xmm0, xmm1, xmm3
    movups   xmm0,[point_light]   ;     calculate light coords.
    movzx    edx,[xres_var]
    cvtsi2ss xmm1,edx
    shufps   xmm1,xmm1,11000000b
    mulps    xmm1,xmm0

    movdqu   xmm3,[xxadd]
    cvtdq2ps xmm3,xmm3
    subps    xmm1,xmm3
  ;  addps    xmm1,xmm1      ; xmm1 - first point light position
    movups   [point_light_coords],xmm1
ret
end if
xy_in_rect:
 ; in:
 ; eax - current y shl 16 + x
 ; ecx - y1 shl 16 + x1
 ; edx - y2 shl 16 + x2
 ;out:
 ; ebx = 0 no, ebx = 1 yes

  movd  xmm0,eax
  movd  xmm1,ecx
  movd  xmm2,edx
  pcmpgtw  xmm1,xmm0
  pcmpgtw  xmm2,xmm0
  pxor     xmm2,xmm1
  pmovmskb ebx,xmm2
  cmp      ebx,1111b
  jne     .end_no
  mov   ebx,1
  ret

;  cmp  ax,cx
;  jl   .end_no
;  cmp  ax,dx
;  jg   .end_no
;  ror  eax,16
;  ror  ecx,16
;  ror  edx,16
;  cmp  ax,cx
;  jl   .end_no
;  cmp  ax,dx
;  jg   .end_no
;  mov  ebx,0x00000001
;  ret
.end_no:
  xor  ebx,ebx
ret

move_texture:
 ;  eax - move x
 ;  ebx - move y
    push ebp

    .x_tex   equ  [ebp-6]
    .y_tex   equ  [ebp-4]
    mov   ebp,esp
    sub   esp,64
    mov   .x_tex,ax
    mov   .y_tex,bx
    cmp   ebx,0
    je    .xx
    jl    .ysub      ;jl

    mov   eax,ebx
    mov   edx,TEX_X
    mul   edx
    mov   ebx,eax
    shl   ebx,2
    lea   esi,[texmap+ebx]
    lea   edi,[texmap]
  ;  cld
    mov   ecx,TEX_X*TEX_Y
    sub   ecx,eax
  ;  rep   movsd
  @@:
    push  dword[esi]
    pop   dword[edi]
    add   esi,4
    add   edi,4
    sub   ecx,1
    jnz   @b
    jmp   .xx
 .ysub:
    mov   esi,texmap
    add   esi,TEX_X*TEX_Y*4
    mov   edi,esi
    neg   ebx
    mov   eax,TEX_X
    mul   ebx
    lea   ecx,[eax*4]
    sub   esi,ecx
  ;  std
    mov   ecx,TEX_X*TEX_Y
    sub   ecx,eax
  @@:
    push  dword[esi]
    pop   dword[edi]
    sub   esi,4
    sub   edi,4
    sub   ecx,1
    jnz   @b
 ;   rep   movsd
  .xx:

    cmp   word .x_tex,0
    je    .end
    jl    .xadd
    movzx eax,word .x_tex
 ;   neg   eax
    lea   edx,[eax*4]
  ;  cld
    xor   ebx,ebx
    lea   esi,[texmap+edx]
    lea   edi,[texmap]
  .next_xsub_l:
    mov   ecx,TEX_X
    sub   ecx,eax
  @@:
    push  dword[esi]
    pop   dword[edi]
    add   edi,4
    add   esi,4
    sub   ecx,1
    jnz   @b
   ; rep   movsd

    add   esi,edx
    add   edi,edx
    add   ebx,1
    cmp   ebx,TEX_Y
    jne   .next_xsub_l
    jmp   .end

   .xadd:

    movsx eax, word .x_tex
    neg   eax

    lea   edx,[eax*4]
  ;  std
    xor   ebx,ebx
    lea   esi,[texmap+TEX_X*TEX_Y*4]
    mov   edi,esi
    sub   esi,edx
  @@:
 .nextxadd_l:
    mov   ecx,TEX_X
    sub   ecx,eax
  @@:
    push  dword[esi]
    pop   dword[edi]
    sub   esi,4
    sub   edi,4
    sub   ecx,1
    jnz   @b
  ;  rep   movsd
    sub   esi,edx
    sub   edi,edx
    add   ebx,1
    cmp   ebx,TEX_Y
    jne   .nextxadd_l;@b

  .end:
   mov    esp,ebp
   pop   ebp
ret

apply_displacement_from_tex:
.vert1_ptr equ dword[ebp-4]
.vert2_ptr equ dword[ebp-8]
.vert3_ptr equ dword[ebp-12]
        push  ebp
        mov   ebp,esp
        sub   esp,128

        xor   ecx,ecx
      .next_vert:
        push   ecx                      ; ecx - vertex counter
        mov    ebx,ecx
        imul   ebx,[i12]
        mov    edi,ebx
        add    edi,[points_normals_rotated_ptr]
        add    ebx,[points_r_ptr]
        movups xmm0,[ebx]
        mov    .vert1_ptr,ebx

        mov    esi,ecx
        mov    eax,ecx
        shl    eax,2
        add    eax,[tex_points_ptr]
        mov    ecx,eax
        movzx  eax,word[eax+2] ; tex y
        mov    edx,TEX_X
        mul    edx
        movzx  ecx,word[ecx]   ; tex x
        add    ecx,eax
        shl    ecx,2
        add    ecx,texmap
        mov    eax,ecx
        mov    ecx,[ecx]
        and    ecx,0x00ffffff
        cmp    ecx,[displ_transparent_col]  ;0x00ffffff
        je     .no  ; no change if transparent - white color
        cmp    [td_wp_flag],0  ; only vertices with positive normal z
                               ; cooficient are computed or all vertices ?
        jz     .whole
        test   dword[edi+8],0x80000000   ; check sign of z coof
        jz     .no
      .whole:
        movzx  ecx,byte[eax]   ; read R,G,B pixel
        movzx  ebx,byte[eax+1]
        add    ecx,ebx
        movzx  ebx,byte[eax+2]
        add    ecx,ebx



        mov    eax,esi
        imul   eax,[i12]
        add    eax,[points_normals_ptr]
        movups xmm7,[eax]
        cvtsi2ss xmm6,ecx
        cvtsi2ss xmm5,[displac_div]
        divss    xmm6,xmm5
        shufps  xmm6,xmm6,0
        mulps   xmm7,xmm6
        addps   xmm0,xmm7
        mov     ebx,.vert1_ptr
        movlps  [ebx],xmm0
        movhlps xmm0,xmm0
        movss   [ebx+8],xmm0
      .no:

        pop    ecx
        inc    ecx
        cmp    cx,[points_count_var]
        jnz    .next_vert

        mov    esp,ebp
        pop    ebp

ret


if 1
triangulize_all_faces: ; all faces from tri_area_x1, y1, x2, y2
; make from each triangle 4 triangles
; teslate
   .new_triangles_ptr  equ dword[ebp-4]
   .new_vertices_ptr   equ dword[ebp-8]
   .edges_list_ptr     equ dword[ebp-12]
   .edges_counter      equ dword[ebp-16]
   .index_mid_vert1    equ word [ebp-20]  ; middle edge vertex indexes
   .index_mid_vert2    equ word [ebp-24]
   .index_mid_vert3    equ word [ebp-28]
   .current_edge       equ      [ebp-32]
   .last_vertex        equ dword[ebp-36]
   .counter_new_tri    equ dword[ebp-40]
   .counter_old_tri    equ dword[ebp-44]
   .tri_list_counter   equ dword[ebp-48]
   .matrix             equ      [ebp-84]


   push  ebp
   mov   ebp,esp
   sub   esp,128

   cmp   [points_count_var],16000
   jg    .end
   cmp   [triangles_count_var],16000
   jg    .end

   ; mem area pointed by [points_r_ptr]
   ; must have correct size


   movzx   eax,[points_count_var]
   mul     [i36]
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
;   int3
 @@:
   mov     .new_vertices_ptr,eax

  mov    esi,[points_rotated_ptr]        ; copy vertexes to new location
  mov    edi,eax
  cld
  movzx  ecx,[points_count_var]
  lea    ecx,[ecx*3]
  rep    movsd

   mov     ebx,[points_r_ptr]
   invoke  VirtualFree, ebx , 0, MEM_RELEASE
   or      eax,eax
   jnz     @f
   int3
 @@:

   movzx   eax,[points_count_var]        ; realloc mem fr vertexes
   mul     [i36]
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  ; int3
 @@:
   mov     [points_r_ptr],eax


   movzx   eax,[triangles_count_var]
   mul     [i24]
   push    eax
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
;   int3
 @@:
   mov     .new_triangles_ptr,eax

   pop      eax

   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or       eax,eax
   jnz      @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
;   int3
  @@:
   mov      .edges_list_ptr,eax



   movzx    eax,[points_count_var]
   mov      .last_vertex,eax
   mov      .edges_counter,1
   xor      ecx,ecx
   mov      .tri_list_counter,0
   mov      .counter_new_tri,0
   mov      .counter_old_tri,0

 .next_triangle:
   push     ecx

   mov      ebx,.counter_old_tri
   add      ebx,[triangles_ptr]

   movzx     edx,word[ebx]
   lea       edx,[edx*3]
   shl       edx,2
   mov       ecx,edx
   add       ecx,[points_normals_rotated_ptr]
   ; calculation vertices only with positive normal vect 'z' coeficient
   cmp      [td_wp_flag],1
   jne       @f
   test      dword[ecx+8],0x80000000
   jz        .skip1
 @@:
   add       edx,.new_vertices_ptr
   movups    xmm0,[edx]
   movlhps   xmm0,xmm0
   cmpnltps  xmm0,dqword[tri_area_x1]
   ; tri_area coords -> float dwords
   pmovmskb  edx,xmm0
   or        al,11110111b
   xor       dl,dh
   cmp       dl,0xff
   je       .do_triang
 .skip1:

   movzx     edx,word[ebx+2]
   lea       edx,[edx*3]
   shl       edx,2
   mov       ecx,edx
   add       ecx,[points_normals_rotated_ptr]
   ; calculation vertices only with positive normal vect 'z' coeficient
   cmp       [td_wp_flag],1
   jne       @f
   test      dword[ecx+8],0x80000000
   jz        .skip2
 @@:
   add       edx,.new_vertices_ptr
   movups    xmm0,[edx]
   movlhps   xmm0,xmm0
   cmpnltps  xmm0,dqword[tri_area_x1]
   ; tri_area coords -> float dwords
   pmovmskb  edx,xmm0
   xor       dl,dh
   cmp       dl,0xff
   je       .do_triang
 .skip2:


   movzx     edx,word[ebx+4]
   lea       edx,[edx*3]
   shl       edx,2
   mov       ecx,edx
   add       ecx,[points_normals_rotated_ptr]
   ; calculation vertices only with positive normal vect 'z' coeficient
   cmp      [td_wp_flag],1
   jne       @f
   test      dword[ecx+8],0x80000000
   jz        .skip_particing
 @@:
   add       edx,.new_vertices_ptr
   movups    xmm0,[edx]
   movlhps   xmm0,xmm0
   cmpnltps  xmm0,dqword[tri_area_x1]
   ; tri_area coords -> float dwords
   pmovmskb  edx,xmm0
   xor       dl,dh
   cmp       dl,0xff
   je       .do_triang

   jmp       .skip_particing


 .do_triang:
;   cmp   [td_wp_flag],1
;   je    @f

   mov      ebx,[ebx]
   mov      .current_edge,ebx  ; two indexes of edge
   mov      edx,ebx  ; edx -> contains cur edge indexes
   mov      ecx,.edges_counter       ; check cur edge in edge list
 @@:
   mov      ebx,ecx
   imul     ebx,[i6]
   add      ebx,.edges_list_ptr  ; each edge from list 3 words
                                 ; 1, 2 - indexes of edge
                                 ; 3 - index of midle point
   cmp      dword[ebx],edx
   je       .index1_found      ; second exam
   ror      edx,16
   cmp      dword[ebx],edx
   je       .index1_found
   loop     @b
 .no_edge_check:
   mov      eax,.last_vertex     ; last vertex index

   shl      eax,2
   lea      eax,[eax*3]
   add      eax,.new_vertices_ptr  ;.new_vertices_ptr  ; eax - desination of cur mid vert
   movzx    ebx,dx   ; edx - cur edge
   shr      edx,16
   imul     edx,[i12]
   imul     ebx,[i12]
   add      edx,.new_vertices_ptr
   add      ebx,.new_vertices_ptr
   movups   xmm0,[edx]
   movups   xmm1,[ebx]
   subps    xmm0,xmm1
   divps    xmm0,[f2x4]
   addps    xmm0,xmm1
   movups   [eax],xmm0
   mov      eax,.last_vertex ; last ver index
   mov      .index_mid_vert1,ax
   mov      ebx,.edges_counter
   imul     ebx,[i6]
   add      ebx,.edges_list_ptr
   push     dword .current_edge  ; two indexes
   pop      dword[ebx]
   mov      word[ebx+4],ax
   add      .last_vertex,1
   add      .edges_counter,1
   jmp      .calc_2cond_ind
 .index1_found:
   mov      ax,word[ebx+4]
   mov      .index_mid_vert1,ax

 .calc_2cond_ind:
   mov      ebx,.counter_old_tri
   add      ebx,[triangles_ptr]
   mov      ebx,[ebx+2]
   mov      .current_edge,ebx  ; two indxes of second edge

   mov      ecx,.edges_counter       ; check cur edge in edge list
 @@:
   mov      ebx,ecx
   imul     ebx,[i6]
   add      ebx,.edges_list_ptr  ; each edge from list 3 words
                                 ; 1, 2 - indexes of edge
                                 ; 3 - index of midle point
   mov      edx,dword .current_edge   ; contains 2 cur edge indexes
   cmp      dword[ebx],edx
   je       .index2_found      ; second exam
   ror      edx,16
   cmp      dword[ebx],edx
   je       .index2_found
   loop     @b
   mov      eax,.last_vertex     ; last vertex index

   shl      eax,2
   lea      eax,[eax*3]
   add      eax,.new_vertices_ptr  ;.new_vertices_ptr  ; eax - desination of cur mid vert
   mov      ebx,.current_edge      ; two indexes of cur edge
   movzx    edx,bx
   shr      ebx,16
   imul     edx,[i12]
   imul     ebx,[i12]
   add      edx,.new_vertices_ptr
   add      ebx,.new_vertices_ptr
   movups   xmm0,[edx]
   movups   xmm1,[ebx]
   subps    xmm0,xmm1
   divps    xmm0,[f2x4]
   addps    xmm0,xmm1
   movups   [eax],xmm0
 ;  movlps   [eax],xmm0
 ;  movhlps  xmm0,xmm0
 ;  movss    [eax+8],xmm0
   mov      eax,.last_vertex ; last ver index
   mov      .index_mid_vert2,ax

   mov      ebx,.edges_counter
   imul     ebx,[i6]
   add      ebx,.edges_list_ptr
   push     dword .current_edge  ; two indexes
   pop      dword[ebx]
   mov      word[ebx+4],ax

   add      .last_vertex,1
   add      .edges_counter,1
   jmp      .calc_3rd_ind

 .index2_found:
   mov      ax,word[ebx+4]
   mov      .index_mid_vert2,ax

 .calc_3rd_ind:

   mov      ebx,.counter_old_tri
   add      ebx,[triangles_ptr]
   mov      ecx,[ebx+2]
   mov      cx,[ebx]
   mov      .current_edge,ecx  ; two indxes of 3rd edge
   mov      edx,ecx  ;word .current_edge   ; contains cur edge indexes
   mov      ecx,.edges_counter       ; check cur edge in edge list
 @@:
   mov      ebx,ecx
   imul     ebx,[i6]
   add      ebx,.edges_list_ptr  ; each edge from list 3 words
                                 ; 1, 2 - indexes of edge
                                 ; 3 - index of midle point
 ;  mov      edx,dword .current_edge   ; contains cur edge indexes
   cmp      dword[ebx],edx
   je       .index3_found      ; second exam
   ror      edx,16
   cmp      dword[ebx],edx
   je       .index3_found
   loop     @b
   mov      eax,.last_vertex     ; last vertex index
   imul     eax,[i12]
   add      eax,.new_vertices_ptr  ;.new_vertices_ptr  ; eax - desination of cur mid vert
   mov      ebx,.current_edge      ; two indexes of cur edge
   movzx    edx,bx
   shr      ebx,16
   imul     edx,[i12]
   imul     ebx,[i12]
   add      edx,.new_vertices_ptr
   add      ebx,.new_vertices_ptr
   movups   xmm0,[edx]
   movups   xmm1,[ebx]
   subps    xmm0,xmm1
   divps    xmm0,[f2x4]
   addps    xmm0,xmm1
   movups   [eax],xmm0
   mov      eax,.last_vertex ; last ver index
   mov      .index_mid_vert3,ax

   mov      ebx,.edges_counter
   imul     ebx,[i6]
   add      ebx,.edges_list_ptr
   push     dword .current_edge  ; two indexes
   pop      dword[ebx]
   mov      word[ebx+4],ax

   add      .last_vertex,1
   add      .edges_counter,1
   jmp      .update_triangles_list
 .index3_found:
   mov      ax,word[ebx+4]
   mov      .index_mid_vert3,ax

 .update_triangles_list:

   mov   ebx,.counter_new_tri
   mov   esi,.counter_old_tri
 ;  shr   ebx,2
 ;  shr   esi,2
   add   ebx,.new_triangles_ptr
   add   esi,[triangles_ptr]


   push  word[esi]
   pop   word[ebx+2]
   push  .index_mid_vert3
   pop   word[ebx]
   push  .index_mid_vert1
   pop   word[ebx+4]

   push  .index_mid_vert1
   pop   word[ebx+8]
   push  .index_mid_vert2
   pop   word[ebx+6]
   push  word[esi+2]
   pop   word[ebx+10]

   push  .index_mid_vert1
   pop   word[ebx+14]
   push  .index_mid_vert3
   pop   word[ebx+12]
   push  .index_mid_vert2
   pop   word[ebx+16]

   push  word[esi+4]
   pop   word[ebx+20]
   push  .index_mid_vert2
   pop   word[ebx+18]
   push  .index_mid_vert3
   pop   word[ebx+22]

   add     .tri_list_counter,4
   add   .counter_new_tri,24
   add   .counter_old_tri,6
   jmp   .tri_list_done

.skip_particing:
 ;  mov     ebx,.counter_old_tri
 ;  shr     ebx,2
 ;  add     ebx,[triangles_ptr]
   push    word[ebx]
   mov     eax,.counter_new_tri
 ;  shr     eax,2
   add     eax,.new_triangles_ptr             ;vertices_ptr
   pop     word[eax]
   push    word[ebx+2]
   pop     word[eax+2]
   push    word[ebx+4]
   pop     word[eax+4]
   add     .counter_old_tri,6
   add     .counter_new_tri,6
   add     .tri_list_counter,1
 .tri_list_done:
   pop   ecx
   inc   ecx
   cmp   cx,[triangles_count_var]
   jnz   .next_triangle


   ; end main loop
;;   int3  ; debug
;;   mov    edi.edges_counter
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; reverse matrix, and transform
;; from new_vertices to points_r
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

   lea    edi,.matrix
   mov    esi,matrix
   call   reverse_mx_3x3
   mov    esi,.new_vertices_ptr
   mov    edi,[points_r_ptr]
   mov    ecx,.last_vertex
 ;  lea    ecx,[ecx*3]
   lea    ebx,.matrix
   call   rotary



   mov     ebx,[triangles_ptr]
   invoke  VirtualFree, ebx , 0, MEM_RELEASE
   or      eax,eax
   jnz     @f
   int3             ; realloc mem fo triangles
 @@:


   movzx    eax,[triangles_count_var]
   imul     eax,[i24]
   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or       eax,eax
   jnz      @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
;   int3
  @@:
   mov      [triangles_ptr],eax

   mov   esi,.new_triangles_ptr
   mov   edi,[triangles_ptr]
   cld
   movzx ecx,[triangles_count_var]
   imul  ecx,[i6]
   rep   movsd




   mov   ecx,.tri_list_counter
   mov   [triangles_count_var],cx

   mov     eax,.last_vertex
   mov     [points_count_var],ax

; release allocated temp mem

;  mov    esi,.new_vertices_ptr        ; copy vertexes to new location
;  mov    edi,[points_r_ptr]
;  cld
;  movzx  ecx,[points_count_var]
;  lea    ecx,[ecx*3]
;  rep    movsd


   mov     ebx,.new_vertices_ptr
   invoke  VirtualFree, ebx , 0, MEM_RELEASE
   or      eax,eax
   jnz     @f
   int3
 @@:

   mov     ebx,.new_triangles_ptr
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or      eax,eax
   jnz     @f
   int3
 @@:

   mov     ebx,.edges_list_ptr
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or      eax,eax
   jnz     @f
   int3
 @@:

  .end:
;  mov   [tp_mem_alloc],1
   mov   esp,ebp
   pop   ebp
ret
end if

load_tetrahedron:

    mov   esi,tetra_points_r
    mov   edi,[points_r_ptr]
    cld
    fninit
    mov   ecx,tetra_points_count*3 + 1
  @@:
    rep   movsd
;    fild  word[esi]
;    fstp  dword[edi]
;    add   esi,2
;    add   edi,4
;    loop  @b
;    movsd

    mov   esi,tetra_triangles
    mov   edi,[triangles_ptr]
    mov   ecx,tetra_triangles_count*12 + 2
    rep   movsw


    mov   ecx,tetra_triangles_count * 12 + 1
    mov   esi,tetra_tex_points
    mov   edi,[tex_points_ptr]
    rep   movsd

    mov  [triangles_count_var],tetra_triangles_count
    mov  [points_count_var],tetra_points_count

ret
if 0
load_box:

    mov   esi,box_points
    mov   edi,[points_r_ptr]
    cld
    fninit
    mov   ecx,box_points_count*3
  @@:
    fild  word[esi]
    fstp  dword[edi]
    add   esi,2
    add   edi,4
    loop  @b
    movsd

    mov   esi,box_triangles
    mov   edi,[triangles_ptr]
    mov   ecx,box_triangles_count*3
    cld
    rep   movsw
    movsd


    mov   ecx,box_triangles_count
    inc   ecx
    mov   esi,box_tex_points
    mov   edi,[tex_points_ptr]
    rep   movsd

    mov  [triangles_count_var],box_triangles_count
    mov  [points_count_var],box_points_count
ret
end if
blur_screen:
;blur n times  ; blur or fire
;in - ecx  times count
;.counter equ dword[esp-4]
.counter1 equ dword[esp-8]

         push       ebp
         mov        ebp,esp
         movaps     xmm5,[blur_sub]
     .again_blur:
         push       ecx
         mov        edi,[screen_ptr]
         movzx      ecx,[xres_var]  ;SIZE_X
         xor        eax,eax
         rep        stosd
;         add        edi,16
;         and        edi,-16
         movzx      ecx,[xres_var]  ;SIZE_X
         movzx      ebx,[yres_var]  ;SIZE_X
         sub        ebx,4
         imul       ecx,ebx
         shr        ecx,2
         movzx      ebx,[xres_var]  ;SIZE_X
  ;       mov        ecx,(SIZE_X*(SIZE_Y-4))*4/16
         mov        esi,edi
         mov        edx,ebx
         shl        edx,2
         sub        esi,edx
     .blr:
     @@:
         movaps     xmm0,[edi+ebx*4]
     ;    movaps     xmm1,[esi];[edi-ebx*4]
         movaps     xmm2,[edi-16]
     ;    movaps     xmm3,[edi+16]

         pavgb      xmm0,[esi]
         pavgb      xmm2,[edi+16]
         pavgb      xmm0,xmm2

         psubusb    xmm0,xmm5  ; importand if fire

         movaps     [edi],xmm0
         add        edi,16
         add        esi,16

         loop       .blr

         xor        eax,eax
         movzx      ecx,[xres_var] ;SIZE_X
         rep        stosd
         pop        ecx
         loop       .again_blur
         mov        esp,ebp
         pop        ebp
ret
if 0
         emms
         push       ebp
         mov        ebp,esp
         push       dword 0x01010101
         push       dword 0x01010101
         movq       mm4,[esp]
     .again_blur:
         push       ecx
         mov        edi,buffer
         mov        ecx,SIZE_X/4
     ;    pxor       mm5,mm5
         xor        eax,eax
         rep        stosd

         mov        ecx,(SIZE_X*(SIZE_Y-4))/8
     .blr:
     @@:
         movq       mm0,[edi+SIZE_X*4]
         movq       mm1,[edi-SIZE_X*4]
         movq       mm2,[edi-4]
         movq       mm3,[edi+4]

         pavgb      mm0,mm1
         pavgb      mm2,mm3
         pavgb      mm0,mm2

         psubusb    mm0,mm4  ; importand if fire

         movq       [edi],mm0
         add         edi,8
         add         esi,8

         loop        .blr

         xor        eax,eax
         mov        ecx,SIZE_X/4
         rep        stosd
         pop         ecx
         loop       .again_blur
         mov        esp,ebp
         pop        ebp


ret
end if
normalize_object1:  ; procedure don't save registers !!
; in:   stack 1 - vertices count to normalise
;       stack 2 - pointer to vertices
; out:  xmm7 - broadcasted reciprocal of maxscale
;       xmm0 - center

        .points_count equ ebp+4
        .points_r     equ ebp+8

     ;  push  ebp
       mov   ebp,esp
   if 0     ;   I tried with SIMD
       mov  ecx,[.points_count]
       sub  ecx,1
       mov  edi,[.points_r]
   ;    points_r ptr  should be aligned
       movups  xmm0,[edi]
       movups  xmm2,[edi]
     @@:
       movups  xmm1,[edi+12]
       maxps   xmm0,xmm1
       minps   xmm2,xmm1
       add     edi,12
       sub     ecx,1
       jnz     @b
       movaps  xmm3,xmm0   ; scale
       subps   xmm0,xmm2
       divps   xmm0,[the_two]
       movaps  xmm3,xmm0
       movaps  xmm4,xmm0
       shufps  xmm3,xmm3,11100001b
       shufps  xmm4,xmm4,11000110b
       maxss   xmm0,xmm3
       maxss   xmm0,xmm4
       shufps  xmm0,xmm0,0


       mov     ecx,[.points_count]   ; do center
       mov     edi,[.points_r]
       xorps   xmm5,xmm5
    @@:
       movups  xmm7,[edi]
       subps   xmm7,xmm0
       maxps   xmm5,xmm7
       movlps  [edi],xmm7
       movhlps xmm7,xmm7
       movss   [edi+8],xmm7
       add     edi,12
       sub     ecx,1
       jnz     @b

       movaps  xmm6,xmm5
       movaps  xmm7,xmm5
       shufps  xmm6,xmm6,11100001b
       shufps  xmm7,xmm7,11000110b
       maxss   xmm5,xmm6
       maxss   xmm5,xmm7
       shufps  xmm5,xmm5,0     ; xmm5 - scale
       rcpps   xmm5,xmm5

       mov     ecx,[.points_count]
       mov     edi,[.points_r]
    @@:
       movups  xmm7,[edi]
       mulps   xmm7,xmm5
       movlps  [edi],xmm7
       movhlps xmm7,xmm7
       movss   [edi+8],xmm7
       add     edi,12
       sub     ecx,1
       jnz     @b

end if

if 1



       xor    ebx,ebx
       xorps  xmm7,xmm7    ;xmm7 - maxxx, max of all maxes
    .find_again_min_max:
       mov    ecx,[.points_count]
       dec    ecx
       mov    edi,[.points_r]
       movss  xmm0,dword[edi+ebx]
       movss  xmm1,dword[edi+ebx]
     @@:
       maxss  xmm0,dword[edi+ebx+12]    ; xmm0 - max
       minss  xmm1,dword[edi+ebx+12]    ; xmm1 - min

       add    edi,12
       loop   @b

       addss  xmm0,xmm1             ; xmm0 - substraction
       mov    eax,2
       cvtsi2ss xmm2,eax
       divss  xmm0,xmm2             ; xmm0 - center
       movss  [center_scale+ebx],xmm0


       mov    edi,[.points_r]
       mov    ecx,[.points_count]
    @@:
       movss  xmm2,[edi+ebx]   ; xmm0 - center
       subss  xmm2,xmm0
       movss  [edi+ebx],xmm2
       maxss  xmm7,xmm2        ; xmm7 - maximum of all
       add    edi,12           ; cooficientes
       loop   @b
       add    ebx,4
       cmp    ebx,12
       jne    .find_again_min_max

       movss  [max_scale],xmm7
    ;   fninit
    ;   fld    [max_scale]
    ;   fchs
    ;   fstp   [max_scale]


    ;   movss  xmm7,[max_scale]
       mov    edi,[.points_r]
       mov    ecx,[.points_count]
       rcpss  xmm7,xmm7
       shufps xmm7,xmm7,0
     @@:
       movups xmm6,[edi]
       mulps  xmm6,xmm7
       movlps [edi],xmm6
       psrldq xmm6,8
       movss  [edi+8],xmm6
       add    edi,12
       loop   @b
end if
       mov    esp,ebp
     ;  pop    ebp
ret 8
if 0
generate_texture1:                  ; draw heart in texture buffer
       .x1       equ  ebp-4
       .y1       equ  ebp-8
       .x2       equ  ebp-12
       .y2       equ  ebp-16
       .x3       equ  ebp-20
       .y3       equ  ebp-24
       .hrt_scale  equ ebp-28

       push      ebp
       mov       ebp,esp
       sub       esp,128

       mov       esi,hrt_points
       mov       edi,hrt_[points_r_ptr]
       mov       ecx,hrt_points_count
       lea       ecx,[ecx*3]
       fninit
     @@:
       fild      word[esi]       ; convert from integer to float
       fstp      dword[edi]
       add       esi,2
       add       edi,4
       loop      @b

       pushad
       push   dword hrt_[points_r_ptr]
       push   dword hrt_points_count
       call   normalize_object1
       popad

     mov   eax,0x00ffffff         ; fill tex buffer
     mov   edi,texmap
     cld
     mov   ecx,TEXTURE_SIZE
     rep   stosd

     mov   dword[.hrt_scale],100.0
     push  [line_buffer_var]            ; draw in texmap buffer
     push  [screen_width_var]
     mov   [screen_width_var],TEX_X
     mov   [line_buffer_var],texmap
     xor   ecx,ecx
     fninit
  @@:
     push  ecx
     lea   ecx,[ecx*3]
     lea   esi,[hrt_triangles+ecx*2]

     movzx eax,word[esi]
     lea   eax,[eax*3]
     shl   eax,2
     fld   dword[eax+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
     fiadd      [tex_x_div2]
   ;  fadd  dword[.hrt_scale]
     fistp dword[.x1]

     fld   dword[eax+4+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
     fiadd      [tex_x_div2]
;     fadd  dword[.hrt_scale]
     fistp dword[.y1]

     movzx eax,word[esi+2]
     lea   eax,[eax*3]
     shl   eax,2
     fld   dword[eax+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
     fiadd      [tex_x_div2]
;     fadd  dword[.hrt_scale]
     fistp dword[.x2]

     fld   dword[eax+4+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
     fiadd      [tex_x_div2]
   ;  fadd  dword[.hrt_scale]
     fistp dword[.y2]


     movzx eax,word[esi+4]
     lea   eax,[eax*3]
     shl   eax,2
     fld   dword[eax+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
    ; fadd  dword[.hrt_scale]
     fiadd      [tex_x_div2]
     fistp dword[.x3]

     fld   dword[eax+4+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
     fiadd      [tex_x_div2]
;     fadd  dword[.hrt_scale]
     fistp dword[.y3]


     pushad
     mov   eax,[.x1]
     mov   ebx,[.y1]
     mov   ecx,[.x2]
     mov   edx,[.y2]
     and   eax,0x000001ff    ; truncate if exceedes texture area
     and   ebx,0x000001ff
     and   ecx,0x000001ff
     and   edx,0x000001ff
     call  linea
     popad

     pushad
     mov   eax,[.x1]
     mov   ebx,[.y1]
     mov   ecx,[.x3]
     mov   edx,[.y3]
     and   eax,0x000001ff
     and   ebx,0x000001ff
     and   ecx,0x000001ff
     and   edx,0x000001ff
     call  linea
     popad

     pushad
     mov   eax,[.x2]
     mov   ebx,[.y2]
     mov   ecx,[.x3]
     mov   edx,[.y3]
     and   eax,0x000001ff
     and   ebx,0x000001ff
     and   ecx,0x000001ff
     and   edx,0x000001ff
     call  linea
     popad

     pop   ecx
     inc   ecx
     cmp   ecx,hrt_triangles_count
     jne   @b


     pop   [screen_width_var]
     pop   [line_buffer_var]

     mov   esp,ebp
     pop   ebp
ret
end if
generate_texture1:  ; do blank texture uses for smooth objects edges
       mov  edi,texmap
       mov  eax,0xffffffff
       mov  ecx,TEX_X*TEX_Y
       cld
       rep  stosd
ret

generate_texture3:
;pushad
       mov  edi,texmap
       xor  ecx,ecx
       cld
     .next:
       xor  ebx,ebx
     @@:
       mov  eax,ecx
       mov  edx,ebx
       xor  eax,edx
       mov  ah,al
       push ax
       shl  eax,8
       pop  ax
;       or   eax,0x00f00000
       ;mov  [edi],eax
       ;add  edi,4
       stosd
       inc  ebx
       cmp  ebx,TEX_X
       jne  @b
       inc  ecx
       cmp  ecx,TEX_Y
       jne  .next
;popad
ret

generate_texture2:
.const equ 32
        cld
        mov     edi,texmap
        xor     bx,bx
     .next_line:
        xor     dx,dx
     .next2stripes:
        mov     eax,-1
        mov     ecx,(TEX_X/.const)
        rep     stosd
        mov     eax,0x00ff0000
        mov     ecx,(TEX_X/.const)
     @@:
        stosd
        loop    @b
        inc     dx
        cmp     dx,.const/2
        jl      .next2stripes
        inc     bx
        cmp     bx,TEX_Y
        jl      .next_line
ret



calc_bumpmap_coords:      ; map texture, bump

      fninit
      fldpi
      fadd      st,st
      mov       esi,[points_r_ptr]
      mov       edi,[tex_points_ptr]
      movzx     ecx,[points_count_var]
      inc       ecx

   .again:
      cmp       [map_flag],2
      jg        .spherical
       ; choose map planar or spherical
       ; map flag 1,2,3 - various planar mapping
      cmp      [map_flag],0
      jne      @f
      xor      eax,eax
      mov      ebx,4
      jmp      .do_planar
  @@:
      cmp      [map_flag],1
      jne      @f
      mov      eax,4
      mov      ebx,8
      jmp      .do_planar
  @@:
;      cmp      [map_flag],3
;      jne      @f
      mov      eax,8
      mov      ebx,4
   .do_planar:
   @@:
      fld       dword[esi+eax]
      fimul     [tex_x_div2]   ; planar map
      fiadd     [tex_x_div2]
      fistp     word[edi]

      fld       dword[esi+ebx]
      fimul     [tex_x_div2]
      fiadd     [tex_x_div2]
      fistp     word[edi+2]

      add      esi,12
      add      edi,4
      loop     .do_planar

      jmp       .end
;      cmp       [map_tex_flag],1
;      jne       .cylindric
   .spherical:
;
;      cmp      [map_flag],3
;      jne      @f
;      xor      eax,eax
;      mov      ebx,4
;      jmp      .do_sp
;  @@:
;      cmp      [map_flag],4
;      jne      @f
;      mov      eax,4
;      mov      ebx,8
;      jmp      .do_sp
;  @@:
;;      cmp      [map_flag],3
;;      jne      @f
;      mov      eax,8
;      mov      ebx,0
;      ; spherical mapping around y axle
;   .do_sp
   @@:
      fld       dword[esi]     ; x coord
      fld       dword[esi+8]   ; z coord
      fpatan                   ; arctg(st1/st)
;      fdiv      .Pi2
      fdiv      st0,st1
      fimul     [tex_x_div2]
      fiadd     [tex_x_div2]
      fistp     word[edi]      ; x

      fld       dword[esi+4]   ; y coord
      fld       dword[esi]     ; x
      fmul      st,st0
      fld       dword[esi+4]   ; y
      fmul      st,st0
      fld       dword[esi+8]   ; z
      fmul      st,st0
      faddp
      faddp
      fsqrt
      fpatan
      fldpi
      fdivp
      fimul    [tex_y_div2]
      fiadd    [tex_y_div2]
      fistp    word[edi+2]     ; y


      add      esi,12
      add      edi,4
      loop     @b
   .end:
      ffree    st0

ret


calc_bumpmap:            ; calculate random bumpmap
;--------------in edi _ pointer to TEX_X x TEX_Y bumpmap

         pushad

         mov     edi, bump_map
         mov     esi,texmap
         mov     ecx,TEXTURE_SIZE
         cmp     [bump_flag],0
         je      .random_bump_map
         ; else bumps according to texture
      @@:
         movzx   ax,byte[esi]
         movzx   bx,byte[esi+1]
         movzx   dx,byte[esi+2]
         add     ax,bx
         add     ax,dx
         cwde
         cdq
         div     [i3]
         stosb
         add     esi,4
         loop    @b
         jmp     .blur_map

;         push    ecx
;         mov     eax,0x88888888
;         mov     ecx,16/4
;         rep     stosd
;         mov     eax,0xffffffff
;         mov     ecx,16/4
;         rep     stosd
;         pop     ecx
;         loop    @b
  .random_bump_map:

  ;       RDTSC
  ;       mov    [rand_seed],ax
      @@:
         push    ecx
         xor     ecx,ecx
         mov     edx,255
         call    random
         stosb
         pop    ecx
         loop   @b

      .blur_map:

      ;   movzx  ecx,[bumps_deep_flag]
         mov    edi, bump_map
         mov    ecx,4
      ;   inc    cx
      .blur:
         xor    esi,esi
         mov    edx,TEXTURE_SIZE
         xor    eax,eax
         xor    ebx,ebx
      @@:
         mov    ebp,esi
         dec    ebp
         and    ebp,TEXTURE_SIZE
         mov    al,byte[ebp+edi]

         mov    ebp,esi
         inc    ebp
         and    ebp,TEXTURE_SIZE
         mov    bl,byte[ebp+edi]
         add    eax,ebx

         mov    ebp,esi
         sub    ebp,TEX_X
         and    ebp,TEXTURE_SIZE
         mov    bl,byte[ebp+edi]
         add    eax,ebx

         mov    ebp,esi
         add    ebp,TEX_X
         and    ebp,TEXTURE_SIZE
         mov    bl,byte[ebp+edi]
         add    eax,ebx

         shr    eax,2
         mov    byte[esi+edi],al

         inc    esi
         dec    edx
         jnz    @b

         loop   .blur
         popad
ret


make_random_lights:
  .temp1  equ ebp-4
  .temp2  equ ebp-8     ;  - light vector generate variables
  .temp3  equ ebp-12
  .col1   equ ebp-20
  .col2   equ ebp-28
  .col3   equ ebp-32
  .max equ 800
        RDTSC
        mov    [rand_seed],ax
        push    ebp
        mov     ebp,esp
        sub     esp,64
        mov     edi,lights
        fninit
        mov     dword[.temp2],.max
        mov     dword[.temp3],.max/2

    .again:
        xor     esi,esi
     @@:
        mov     edx,.max
        xor     ecx,ecx
        call    random
        sub     eax,.max/2
        mov     dword[.temp1],eax
        fild    dword[.temp1]
        fidiv   dword[.temp3]
        fstp    dword[edi+esi*4]
        inc     esi
        cmp     esi,2
        jne     @b

  .max1 equ 1000
        mov     dword[.temp2],.max1/2
        mov     edx,.max1
        xor     ecx,ecx
        call    random
        mov     dword[.temp1],eax
        fild    dword[.temp1]
        fchs
        fidiv   dword[.temp2]
        fstp    dword[edi+8]

        xor     esi,esi
     @@:
        mov     ecx,220            ; max colors and shine  , ecx = 200 - more bright shading
        mov     edx,255
        call    random
        movzx   ax,al
        mov     [edi+28+esi*2],ax
        inc     esi
        cmp     esi,4
        jne     @b

        xor     esi,esi
     @@:
        mov     ecx,100              ; orginal colors
        movzx   edx,word[edi+28+esi*2]
        call    random
        movzx   ax,al
        mov     [edi+12+esi*2],ax
        inc     esi
        cmp     esi,3
        jne     @b

        xor     esi,esi
     @@:
        mov     ecx,1               ; min cols
        movzx   edx,word[edi+12+esi*2]
        call    random
        movzx   ax,al
        mov     [edi+20+esi*2],ax
        inc     esi
        cmp     esi,3
        jne     @b

        add     edi,LIGHT_SIZE ;22
        cmp     edi,lightsend
        jne     .again


        mov       esi,lights
        mov       edi,lights_aligned



     .do_aligned: ; make aligned float lights used
                  ; in all Real Phong rendering models
        movups    xmm0,[esi]
        orps      xmm0,[z_minus_mask]
        movaps    xmm1,xmm0    ; normalize
        mulps     xmm1,xmm1
        andps     xmm1,[zero_hgst_dd]
        haddps    xmm1,xmm1
        haddps    xmm1,xmm1
        rsqrtps   xmm1,xmm1
        mulps     xmm0,xmm1


if 0
        mov       ecx,1
        mov       edx,255
        call      random
        sub       eax,128
        cvtsi2ss  xmm0,eax
        divss     xmm0,[f256d]
        mov       ecx,1
        mov       edx,255
        call      random
        sub       eax,128
        cvtsi2ss  xmm1,eax
        divss     xmm1,[f256d]
        mov       ecx,1
        mov       edx,255
        call      random
        sub       eax,128
        cvtsi2ss  xmm2,eax
        divss     xmm2,[f256d]

        shufps    xmm1,xmm1,11100001b
        por       xmm0,xmm1
        movlhps   xmm0,xmm2
        orps      xmm0,[z_minus_mask]
        movaps    xmm1,xmm0
        mulps     xmm1,xmm1

        andps     xmm1,[zero_hgst_dd]
        haddps    xmm1,xmm1
        haddps    xmm1,xmm1
        rsqrtps   xmm1,xmm1
        mulps     xmm0,xmm1
end if


        movq      xmm1,[esi+12]
        movq      xmm2,[esi+12+8]
        movq      xmm3,[esi+12+16]
     ;   psrlw     xmm1,2
        punpcklwd xmm1,[the_zero]
        punpcklwd xmm2,[the_zero]
        punpcklwd xmm3,[the_zero]
        psrld     xmm1,1
        psrld     xmm2,1
      ;  psrld     xmm3,1

        andps     xmm0,[zero_hgst_dd]
        cvtdq2ps  xmm1,xmm1
        cvtdq2ps  xmm2,xmm2
        cvtdq2ps  xmm3,xmm3
        andps     xmm1,[zero_hgst_dd]
        andps     xmm2,[zero_hgst_dd]
        andps     xmm3,[zero_hgst_dd]

        movaps    [edi],xmm0
        movaps    [edi+16],xmm1
        movaps    [edi+32],xmm2
        movaps    [edi+48],xmm3

        add       edi,64
        add       esi,LIGHT_SIZE
        cmp       esi,lightsend
        jne       .do_aligned


        mov     esp,ebp
        pop     ebp
ret

random:
;  in  - ecx - min
;        edx - max
;  out - eax - random number
         mov    bx,[rand_seed]
         add    bx,0x9248
         ror    bx,3
         mov    [rand_seed],bx

         mov    ax,dx
         sub    ax,cx
         mul    bx
         mov    ax,dx
         add    ax,cx
         cwde
ret

do_color_buffer:         ; do color buffer for Gouraud, flat shading
;env_map 512 x 512 x 3 bytes    ; many lights using
.temp  equ word   [ebp-2]
.nz    equ dword  [ebp-6]  ; dword
.ny    equ dword  [ebp-10]
.nx    equ dword  [ebp-14]
.col_r equ    [ebp-16]
.col_g equ    [ebp-17]
.col_b equ    [ebp-18]

         push     ebp
         mov      ebp,esp
         sub      esp,20
         mov      edi,color_map
         fninit

         mov      dx,- TEX_Y / 2 ;-256   ; dx - vertical coordinate = y
    .ie_ver:
         mov      cx,- TEX_X / 2 ;256   ; cx - horizontal coord = x
    .ie_hor:
         mov      .temp,cx
         fild     .temp
         fidiv    [tex_x_div2];[i256]st = Nx - vector normal x cooficient
         fst      .nx
         fmul     st,st0
         mov      .temp,dx
         fild     .temp
         fidiv    [tex_y_div2];[i256]st = Ny - vector normal y coeficient
         fst      .ny
         fmul     st,st0
         faddp
         fld1
         fchs
         faddp
         fabs
         fsqrt
         fchs
         fstp     .nz              ; st - Nz - vect normal z coeficient
         xor      ebx,ebx
         mov      dword .col_b, 0
     .light:
         push     edi   ;env_map
         lea      esi,[lights+ebx]
         lea      edi,.nx
         call     dot_product
         pop      edi
         fcom     dword[dot_min]
         fstsw    ax
         sahf
         ja       .env_ok1  ;compare with dot_max
         ffree    st

        jmp       .update_counters
      .env_ok1:
         fcom    dword[dot_max]
         fstsw   ax
         sahf
         jb      .env_ok2     ; calc col
         ffree   st
         jmp     .update_counters
      .env_ok2:            ;calc col
         push     ebp
         push     word[esi+36]   ; -  shines
         push     word[esi+12]   ; b  orginal color
         push     word[esi+14]   ; g
         push     word[esi+16]   ; r
         push     word[esi+28]   ; b  max color
         push     word[esi+30]   ; g
         push     word[esi+32]   ; r
         push     word[esi+20]   ; b  min col
         push     word[esi+22]   ; g
         push     word[esi+24]   ; r
         push     eax         ; earlier - dot pr
      ;  fstp     .dot_product
      ;  push     .dot_product
         call     calc_one_col
         pop      ebp
         ; eax-0x00rrggbb
         cmp      al,.col_b
         jbe      @f
         mov      .col_b,al
   @@:
         shr      ax,8
         cmp      al,.col_g
         jbe      @f
         mov      .col_g,al
   @@:
         shr      eax,16
         cmp      al,.col_r
         jbe      @f
         mov      .col_r,al
  @@:
 .update_counters:                                  ; update and jump when neccesery
        add     ebx,LIGHT_SIZE
        cmp     bx,[all_lights_size]
        jl      .light    ; next_light
        mov     eax,dword .col_b
        stosd

        inc     cx
        cmp     cx,TEX_X / 2 ;256
        jne     .ie_hor

        inc     dx
        cmp     dx,TEX_X / 2 ;256
        jne     .ie_ver

    .env_done:
         mov     esp,ebp
         pop     ebp

ret




init_envmap2:         ; do env_map
;env_map 512 x 512 x 4 bytes
.temp  equ word   [ebp-2]
.nEy   equ word   [ebp-4]
.nEx   equ word   [ebp-6]
.col_r equ        [ebp-8]
.col_g equ        [ebp-9]
.col_b equ        [ebp-10]

         push     ebp
         mov      ebp,esp
         sub      esp,20
         mov      edi,envmap
         fninit

         mov      dx,- TEX_Y / 2 ;256   ; dx - vertical coordinate = y
    .ie_ver:
         mov      cx,- TEX_X / 2 ;256   ; cx - horizontal coord = x
    .ie_hor:
         xor      ebx,ebx
         mov      dword .col_b, 0
     .light:
         lea      esi,[lights+ebx]
         fld      dword[esi]     ; light vector x cooficient
         fimul    [tex_x_div2] ;[i256]
         mov      .temp,cx
         fisubr   .temp
         fistp    .nEx
         fld      dword[esi+4]   ; light vector y cooficient
         fimul    [tex_y_div2] ;[i256]
         mov      .temp,dx
         fisubr   .temp
         fistp    .nEy

         cmp      .nEx,- TEX_X / 2 ;256
         jl       .update_counters
         cmp      .nEy,- TEX_Y / 2 ;256
         jl       .update_counters
         cmp      .nEx,TEX_X / 2 ;256
         jg       .update_counters
         cmp      .nEy,TEX_Y / 2 ;256
         jg       .update_counters

         fild     .nEx
         fmul     st,st0
         fild     .nEy
         fmul     st,st0
         faddp
         fsqrt
         fisubr   [i256]
         fmul     [env_const]
         fidiv    [i256]   ; st - 'virtual' dot product

         fcom     dword[dot_max]
         fstsw    ax
         sahf
         jb       @f
         ffree    st
         fld1     ;[dot_max]
      @@:
         fcom     dword[dot_min]
         fstsw    ax
         sahf
         ja       @f
         ffree    st
         fldz     ;[dot_min]
      @@:
         push     ebp
         push     word[esi+36]   ; -  shines
         push     word[esi+12]   ; b  orginal color
         push     word[esi+14]   ; g
         push     word[esi+16]   ; r
         push     word[esi+28]   ; b  max color
         push     word[esi+30]   ; g
         push     word[esi+32]   ; r
         push     word[esi+20]   ; b  min col
         push     word[esi+22]   ; g
         push     word[esi+24]   ; r
         push     eax            ;    earlier - dot pr
      ;  fstp     .dot_product
      ;  push     .dot_product
         call     calc_one_col
         pop      ebp
         ; eax-0x00rrggbb
         cmp      al,.col_b
         jbe      @f
         mov      .col_b,al
   @@:                        ;  eax - ggbb00rr
         shr      ax,8
         cmp      al,.col_g
         jbe      @f
         mov      .col_g,al
   @@:                        ;  eax - bb0000gg
         shr      eax,16
         cmp      al,.col_r
         jbe      @f
         mov      .col_r,al
   @@:
   .update_counters:                     ; update and jump when neccesery
         add      ebx,LIGHT_SIZE
         cmp      bx,[all_lights_size]
         jl       .light    ; next_light
         mov      eax,dword .col_b
         or        eax,0xff000000
         stosd
     ;    dec      edi

         inc      cx
         cmp      cx,TEX_X / 2 ;256
         jne      .ie_hor

         inc      dx
         cmp      dx,TEX_Y / 2 ;256
         jne     .ie_ver

         mov     esp,ebp
         pop     ebp
ret


  calc_one_col:
; procedure don't save registers !!!
; in -   st - dot_product
;        stack - other parameters
; out - eax - 0x00rrggbb
.dot_prd   equ dword[ebp+4]           ; dot product   - cos x  - not now
.min_col_r equ word[ebp+8]            ; minimum color - ambient
.min_col_g equ word[ebp+10]
.min_col_b equ word[ebp+12]
.max_col_r equ word[ebp+14]           ; maximum color - specular
.max_col_g equ word[ebp+16]
.max_col_b equ word[ebp+18]
.org_col_r equ word[ebp+20]           ; orginal color - diffuse
.org_col_g equ word[ebp+22]
.org_col_b equ word[ebp+24]
.n         equ word[ebp+26]           ; shines - not implemented
.temp      equ word[ebp-2]
.color_sum_r equ dword[ebp-6]
.color_sum_g equ dword[ebp-10]
.color_sum_b equ dword[ebp-14]
; color = ambient+cos(x)*diffuse+(cos(x)^n)*specular
         mov     ebp,esp
         sub     esp,14

         mov      ax,.min_col_r
         add      ax,.max_col_r
         add      ax,.org_col_r
         cwde
         mov      .color_sum_r,eax

         mov      ax,.min_col_g
         add      ax,.max_col_g
         add      ax,.org_col_g
         cwde
         mov      .color_sum_g,eax

         mov      ax,.min_col_b
         add      ax,.max_col_b
         add      ax,.org_col_b
         cwde
         mov      .color_sum_b,eax


;         fld     .dot_prd
       ;  fild    .n
       ;  fxch    st1
       ;  fabs
       ;  fyl2x                     ;
       ;  f2xm1
       ;  fld1
       ;  faddp        ; st =  dot_product ^ n

         fld     st            ; copy dot pr
         fmul    st,st0
         fmul    st,st0
         fmul    st,st0
         cmp     .n,255            ; .n = 255 -> spot light
         jne     @f
         fmul    st,st0
         fmul    st,st0
         fmul    st,st0
      @@:
         fld     st            ; st0=st1=dot_pr^n, st2=dot_pr
         fimul   .max_col_b
         fild    .org_col_b
         fmul    st,st3
         faddp                 ; st0=first piece of col, st1=dot_pr^n..
         fiadd   .min_col_b
         fimul   .max_col_b
         fidiv   .color_sum_b
         fistp   .temp
         movzx   eax,.temp
         shl     eax,16

         fld     st
         fimul   .max_col_g
         fild    .org_col_g
         fmul    st,st3
         faddp
         fiadd   .min_col_g
         fimul   .max_col_g
         fidiv   .color_sum_g
         fistp   .temp
         mov     ax,.temp
         mov     ah,al
         shl     eax,8

         fimul   .max_col_r
         fild    .org_col_r
         fmulp   st2,st
         faddp
         fiadd   .min_col_r
         fimul   .max_col_r
         fidiv   .color_sum_r
         fistp   .temp
         mov     ax,.temp          ;eax -  0xbbgg00rr
     ;   mov     ah,al
         ror     eax,16
         xchg    al,ah             ; eax - 0x00rrggbb
         mov     esp,ebp
ret 24
